local toc, data = ...
local AddonId = toc.identifier

NG = {}
NG.player = {}
NG.units = {}

local function DistanceUpdate(xValues, yValues, zValues)
	for unitId,value in pairs(xValues) do
		if unitId and unitId == NG.player.id then
			for idx in pairs(NG.units) do
				if idx ~= NG.player.id then
					local unit = WT.Units[idx]
					if unit and NG.player.coord[1] and NG.player.coord[2] and NG.player.coord[3] and unit.coord[1] and unit.coord[2] and unit.coord[3] then
						WT.Units[unit.id].distance = WT.Utility.MeasureDistanceSquared( 
							NG.player.coord[1], NG.player.coord[2], NG.player.coord[3], 
							unit.coord[1], unit.coord[2], unit.coord[3])
					end
				end
			end
		elseif WT.Units[unitId].player then
			local unit = WT.Units[unitId]
			if unit and NG.player.coord[1] and NG.player.coord[2] and NG.player.coord[3] and unit.coord[1] and unit.coord[2] and unit.coord[3] then
				distance = WT.Utility.MeasureDistanceSquared( 
					NG.player.coord[1], NG.player.coord[2], NG.player.coord[3], 
					unit.coord[1], unit.coord[2], unit.coord[3])
				WT.Units[unit.id].distance = distance
			end
		end
	end
end

-- This is where the distance between the unit and the player is stored
local function PopulateDistance(unitId)
	local detail = WT.Units[unitId]
	if detail.id and detail.player then
		WT.Units[detail.id].distance = 0
		NG.units = Inspect.Unit.List()
		if NG.player.id and NG.player.coord[1] and NG.player.coord[2] and NG.player.coord[3] and detail.coord[1] and detail.coord[2] and detail.coord[3] then
			WT.Units[detail.id].distance = WT.Utility.MeasureDistanceSquared(
				NG.player.coord[1], NG.player.coord[2], NG.player.coord[3],
				detail.coord[1], detail.coord[2], detail.coord[3]) 
		end
	end
end

local function OnUnitAdded(unitId)
	if unitId == WT.Player.id then
		NG.player = WT.Player
		NG.player.distance = 0
	end
	PopulateDistance(unitId)
end

WT.Unit.CreateVirtualProperty("blockedOrRanged", { "distance", "blocked" },
	function(unit)
		if unit.player then
			if unit.blocked or ((unit.distance or 0) >= 1296) then  -- This is set to 36m to account for the 1m radius of a player unit.
				return true
			else
				return false
			end
		else
			return false
		end
	end)


table.insert(Event.Unit.Detail.Coord, { DistanceUpdate, AddonId, AddonId .. "_DistanceUpdate" })
table.insert(WT.Event.UnitAdded, { OnUnitAdded, AddonId, AddonId .. "_UnitAdded" })
