------------------------------------------------------------------------
--------------------- Super Meter - DPS/HPS Parser ---------------------
------------------------------------------------------------------------

SuperMeter = {
	version = "SLE 2.6",
	UI = {},
	Util = {},
	Event = {},
	state = {
		encounters = {},
		encounterIndex = 0,
		encounterOffset = 0,
		lastUpdate = -1,
	},
}

SuperMeter_alpha = 0.8
SuperMeter_display = "Calling"
SuperMeter_bossActive = false
SuperMeter_enabled = true
SuperMeter_fontSize = 14
SuperMeter_growUp = false
SuperMeter_logEnabled = true
SuperMeter_logX = 626
SuperMeter_logY = 760
SuperMeter_maxSlots = 5
SuperMeter_mode = "DPS"
SuperMeter_mode1 = "DPS"
SuperMeter_mode2 = "HPS"
SuperMeter_side = "Allies"
SuperMeter_width = 268
SuperMeter_x = 820
SuperMeter_y = 600

Interface = {}
function Interface:new()
	local o = {
		state = {},
		offsetY = 0,
	}

	setmetatable(o, self)
	self.__index = self

	local Context = UI.CreateContext("Context")
	local Height = 0

	if SuperMeter_fontSize == 14 then
		Height = 23.6
	else
		Height = 21.88
	end

	o.main = UI.CreateFrame("Frame", "SuperMeter Main", Context)
	o.main:SetBackgroundColor(0, 0, 0, SuperMeter_alpha)

	o.title = UI.CreateFrame("Text", "SuperMeter Main Title", Context)
	o.title:SetPoint("TOPCENTER", o.main, "TOPCENTER", 0, -2)
	o.title:SetFont("SuperMeter", "Swansea.ttf")
	o.title:SetFontSize(SuperMeter_fontSize + 2)
	o.title:SetText("Super Meter")
	o.title:SetParent(o.main)

	o.menu = UI.CreateFrame("Text", "SuperMeter Main Menu", Context)
	o.menu:SetPoint("TOPLEFT", o.main, "TOPLEFT", 8, 0)
	o.menu:SetFont("SuperMeter", "Swansea.ttf")
	o.menu:SetFontSize(SuperMeter_fontSize)
	o.menu:SetParent(o.main)
	o.menu:SetText("MENU")

	o.clear = UI.CreateFrame("Text", "SuperMeter Main Clear", Context)
	o.clear:SetPoint("TOPRIGHT", o.main, "TOPRIGHT", -48.88, 0)
	o.clear:SetFont("SuperMeter", "Swansea.ttf")
	o.clear:SetFontSize(SuperMeter_fontSize)
	o.clear:SetParent(o.main)
	o.clear:SetText("C")

	o.new = UI.CreateFrame("Text", "SuperMeter Main New", Context)
	o.new:SetPoint("TOPCENTER", o.clear, "TOPCENTER", 14, 0)
	o.new:SetFont("SuperMeter", "Swansea.ttf")
	o.new:SetFontSize(SuperMeter_fontSize)
	o.new:SetParent(o.main)
	o.new:SetText("N")

	o.force = UI.CreateFrame("Text", "SuperMeter Main Force", Context)
	o.force:SetPoint("TOPCENTER", o.new, "TOPCENTER", 14, 0)
	o.force:SetFont("SuperMeter", "Swansea.ttf")
	o.force:SetFontSize(SuperMeter_fontSize)
	o.force:SetParent(o.main)
	o.force:SetText("F")

	o.log = UI.CreateFrame("Text", "SuperMeter Main Log", Context)
	o.log:SetPoint("TOPCENTER", o.force, "TOPCENTER", 14, 0)
	o.log:SetFont("SuperMeter", "Swansea.ttf")
	o.log:SetVisible(SuperMeter_logEnabled)
	o.log:SetFontSize(SuperMeter_fontSize)
	o.log:SetParent(o.main)
	o.log:SetText("D")

	o.help = UI.CreateFrame("Text", "SuperMeter Main Help", Context)
	o.help:SetPoint("TOPCENTER", o.force, "TOPCENTER", 14, 0)
	o.help:SetFont("SuperMeter", "Swansea.ttf")
	o.help:SetVisible(not SuperMeter_logEnabled)
	o.help:SetFontSize(SuperMeter_fontSize)
	o.help:SetParent(o.main)
	o.help:SetText("H")

	o.mainslider = UI.CreateFrame("RiftScrollbar", "Combat Slider", Context)
	o.mainslider:SetPoint("CENTERLEFT", o.main, "CENTERLEFT", -20, 0)
	o.mainslider:SetParent(o.main)
	o.mainslider:SetVisible(false)
	o.mainslider:SetHeight(80)
	o.mainslider:SetWidth(18)

	o.menus = UI.CreateFrame("Frame", "SuperMeter Menu", Context)
	o.menus:SetVisible(false)
	o.menus:SetHeight(54)
	o.menus:SetWidth(100)
	o.menus:SetLayer(2)

	o.menusbg = UI.CreateFrame("Frame", "SuperMeter Menu Background", Context)
	o.menusbg:SetPoint("TOPCENTER", o.menus, "TOPCENTER", 0, 2.86)
	o.menusbg:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.menusbg:SetParent(o.menus)
	o.menusbg:SetHeight(48)
	o.menusbg:SetWidth(94)
	o.menusbg:SetLayer(4)

	o.menus1 = UI.CreateFrame("Text", "SuperMeter Menu 1", Context)
	o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0, 2)
	o.menus1:SetFont("SuperMeter", "Swansea.ttf")
	o.menus1:SetFontSize(SuperMeter_fontSize)
	o.menus1:SetParent(o.menusbg)
	o.menus1:SetHeight(24)

	o.menus2 = UI.CreateFrame("Text", "SuperMeter Menu 4", Context)
	o.menus2:SetPoint("BOTTOMLEFT", o.menusbg, "BOTTOMLEFT", 8, -0.8)
	o.menus2:SetFont("SuperMeter", "Swansea.ttf")
	o.menus2:SetFontSize(SuperMeter_fontSize)
	o.menus2:SetParent(o.menusbg)
	o.menus2:SetHeight(24)

	o.menus3 = UI.CreateFrame("Text", "SuperMeter Menu 5", Context)
	o.menus3:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0, 24)
	o.menus3:SetFont("SuperMeter", "Swansea.ttf")
	o.menus3:SetFontSize(SuperMeter_fontSize)
	o.menus3:SetParent(o.menusbg)
	o.menus3:SetText("00 - 00")
	o.menus3:SetHeight(24)

	o.menus4 = UI.CreateFrame("Text", "SuperMeter Menu 6", Context)
	o.menus4:SetPoint("BOTTOMRIGHT", o.menusbg, "BOTTOMRIGHT", -8, -0.8)
	o.menus4:SetFont("SuperMeter", "Swansea.ttf")
	o.menus4:SetFontSize(SuperMeter_fontSize)
	o.menus4:SetParent(o.menusbg)
	o.menus4:SetHeight(24)

	o.time = UI.CreateFrame("Text", "Time Main", Context)
	o.time:SetPoint("TOPLEFT", o.main, "TOPLEFT", 12.88, 24)
	o.time:SetFont("SuperMeter", "Swansea.ttf")
	o.time:SetFontSize(SuperMeter_fontSize)
	o.time:SetText("Time: 00:00")
	o.time:SetParent(o.main)

	o.relation = UI.CreateFrame("Text", "Relation Main", Context)
	o.relation:SetPoint("TOPCENTER", o.main, "TOPCENTER", -0.88, 24)
	o.relation:SetFont("SuperMeter", "Swansea.ttf")
	o.relation:SetFontSize(SuperMeter_fontSize)
	o.relation:SetParent(o.main)

	o.mode1 = UI.CreateFrame("Text", "Combat Mode 1", Context)
	o.mode1:SetPoint("TOPCENTER", o.help, "TOPCENTER", -64, 24)
	o.mode1:SetFont("SuperMeter", "Swansea.ttf")
	o.mode1:SetFontSize(SuperMeter_fontSize)
	o.mode1:SetText(SuperMeter_mode1)
	o.mode1:SetParent(o.main)

	o.mode2 = UI.CreateFrame("Text", "Combat Mode 2", Context)
	o.mode2:SetPoint("TOPCENTER", o.mode1, "TOPCENTER", 50, 0)
	o.mode2:SetFont("SuperMeter", "Swansea.ttf")
	o.mode2:SetFontSize(SuperMeter_fontSize)
	o.mode2:SetText(SuperMeter_mode2)
	o.mode2:SetParent(o.main)

	o.modeselectbg = UI.CreateFrame("Frame", "Mode Select Background", Context)
	o.modeselectbg:SetBackgroundColor(0, 0, 0, 0.8)
	o.modeselectbg:SetParent(o.main)
	o.modeselectbg:SetVisible(false)
	o.modeselectbg:SetHeight(294)
	o.modeselectbg:SetWidth(146)
	o.modeselectbg:SetLayer(8)

	o.modeselect = UI.CreateFrame("Frame", "Mode Select Main", Context)
	o.modeselect:SetPoint("TOPCENTER", o.modeselectbg, "TOPCENTER", -0.2, 4)
	o.modeselect:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.modeselect:SetParent(o.main)
	o.modeselect:SetVisible(false)
	o.modeselect:SetHeight(286)
	o.modeselect:SetWidth(136)
	o.modeselect:SetLayer(10)

	o.mode1select = UI.CreateFrame("Text", "Mode Select 1", Context)
	o.mode1select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 0)
	o.mode1select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode1select:SetFontSize(SuperMeter_fontSize)
	o.mode1select:SetText("Damage P/s")
	o.mode1select:SetParent(o.modeselect)
	o.mode1select:SetHeight(20)

	o.mode2select = UI.CreateFrame("Text", "Mode Select 2", Context)
	o.mode2select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 20)
	o.mode2select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode2select:SetFontSize(SuperMeter_fontSize)
	o.mode2select:SetText("Damage")
	o.mode2select:SetParent(o.modeselect)
	o.mode2select:SetHeight(20)

	o.mode3select = UI.CreateFrame("Text", "Mode Select 3", Context)
	o.mode3select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 40)
	o.mode3select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode3select:SetFontSize(SuperMeter_fontSize)
	o.mode3select:SetText("Damage Taken")
	o.mode3select:SetParent(o.modeselect)
	o.mode3select:SetHeight(20)

	o.mode4select = UI.CreateFrame("Text", "Mode Select 4", Context)
	o.mode4select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", -0.8, 60)
	o.mode4select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode4select:SetFontSize(SuperMeter_fontSize)
	o.mode4select:SetText("Overkill")
	o.mode4select:SetParent(o.modeselect)
	o.mode4select:SetHeight(20)

	o.mode5select = UI.CreateFrame("Text", "Mode Select 5", Context)
	o.mode5select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 80)
	o.mode5select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode5select:SetFontSize(SuperMeter_fontSize)
	o.mode5select:SetText("Healing P/s")
	o.mode5select:SetParent(o.modeselect)
	o.mode5select:SetHeight(20)

	o.mode6select = UI.CreateFrame("Text", "Mode Select 6", Context)
	o.mode6select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 100)
	o.mode6select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode6select:SetFontSize(SuperMeter_fontSize)
	o.mode6select:SetText("Healing")
	o.mode6select:SetParent(o.modeselect)
	o.mode6select:SetHeight(20)

	o.mode7select = UI.CreateFrame("Text", "Mode Select 7", Context)
	o.mode7select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 120)
	o.mode7select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode7select:SetFontSize(SuperMeter_fontSize)
	o.mode7select:SetText("Healing Taken")
	o.mode7select:SetParent(o.modeselect)
	o.mode7select:SetHeight(20)

	o.mode8select = UI.CreateFrame("Text", "Mode Select 8", Context)
	o.mode8select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 140)
	o.mode8select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode8select:SetFontSize(SuperMeter_fontSize)
	o.mode8select:SetText("Overhealing P/s")
	o.mode8select:SetParent(o.modeselect)
	o.mode8select:SetHeight(20)

	o.mode9select = UI.CreateFrame("Text", "Mode Select 9", Context)
	o.mode9select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 160)
	o.mode9select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode9select:SetFontSize(SuperMeter_fontSize)
	o.mode9select:SetText("Overhealing")
	o.mode9select:SetParent(o.modeselect)
	o.mode9select:SetHeight(20)

	o.mode10select = UI.CreateFrame("Text", "Mode Select 10", Context)
	o.mode10select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 180)
	o.mode10select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode10select:SetFontSize(SuperMeter_fontSize)
	o.mode10select:SetText("Absorbed Damage")
	o.mode10select:SetParent(o.modeselect)
	o.mode10select:SetHeight(20)

	o.mode11select = UI.CreateFrame("Text", "Mode Select 11", Context)
	o.mode11select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 200)
	o.mode11select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode11select:SetFontSize(SuperMeter_fontSize)
	o.mode11select:SetText("Avoided Damage")
	o.mode11select:SetParent(o.modeselect)
	o.mode11select:SetHeight(20)

	o.mode12select = UI.CreateFrame("Text", "Mode Select 12", Context)
	o.mode12select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0.2, 220)
	o.mode12select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode12select:SetFontSize(SuperMeter_fontSize)
	o.mode12select:SetText("Blocked Damage")
	o.mode12select:SetParent(o.modeselect)
	o.mode12select:SetHeight(20)

	o.mode13select = UI.CreateFrame("Text", "Mode Select 13", Context)
	o.mode13select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0, 240)
	o.mode13select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode13select:SetFontSize(SuperMeter_fontSize)
	o.mode13select:SetText("Deflected Damage")
	o.mode13select:SetParent(o.modeselect)
	o.mode13select:SetHeight(20)

	o.mode14select = UI.CreateFrame("Text", "Mode Select 14", Context)
	o.mode14select:SetPoint("TOPCENTER", o.modeselect , "TOPCENTER", 0.4, 260)
	o.mode14select:SetFont("SuperMeter", "Swansea.ttf")
	o.mode14select:SetFontSize(SuperMeter_fontSize)
	o.mode14select:SetText("Missed Damage")
	o.mode14select:SetParent(o.modeselect)
	o.mode14select:SetHeight(20)

	o.combatmask1 = UI.CreateFrame("Mask", "Combat Mask 1", Context)
	o.combatmask1:SetPoint("TOPLEFT", o.main, "TOPLEFT", 4, 48.88)
	o.combatmask1:SetParent(o.main)

	o.combatmask2 = UI.CreateFrame("Mask", "Combat Mask 2", Context)
	o.combatmask2:SetPoint("CENTERRIGHT", o.combatmask1, "CENTERRIGHT", 50, 0)
	o.combatmask2:SetParent(o.main)
	o.combatmask2:SetWidth(48)

	o.combatmask3 = UI.CreateFrame("Mask", "Combat Mask 3", Context)
	o.combatmask3:SetPoint("CENTERRIGHT", o.combatmask2, "CENTERRIGHT", 50, 0)
	o.combatmask3:SetParent(o.main)
	o.combatmask3:SetWidth(48)

	o.combattext1 = UI.CreateFrame("Text", "Combat Text 1", Context)
	o.combattext1:SetPoint("TOPLEFT", o.combatmask1, "TOPLEFT", 0, 0)
	o.combattext1:SetFont("SuperMeter", "Swansea.ttf")
	o.combattext1:SetFontSize(SuperMeter_fontSize)
	o.combattext1:SetParent(o.combatmask1)
	o.combattext1:SetLayer(2)

	o.combattext2 = UI.CreateFrame("Text", "Combat Text 2", Context)
	o.combattext2:SetPoint("TOPCENTER", o.combatmask2, "TOPCENTER", 0, 0)
	o.combattext2:SetFont("SuperMeter", "Swansea.ttf")
	o.combattext2:SetFontSize(SuperMeter_fontSize)
	o.combattext2:SetParent(o.combatmask2)
	o.combattext2:SetWidth(42)
	o.combattext2:SetLayer(2)

	o.combattext3 = UI.CreateFrame("Text", "Combat Text 3", Context)
	o.combattext3:SetPoint("TOPCENTER", o.combatmask3, "TOPCENTER", 0, 0)
	o.combattext3:SetFont("SuperMeter", "Swansea.ttf")
	o.combattext3:SetFontSize(SuperMeter_fontSize)
	o.combattext3:SetParent(o.combatmask3)
	o.combattext3:SetWidth(42)
	o.combattext3:SetLayer(2)

	o.unitbar1 = UI.CreateFrame("Text", "Unit Bar 1", Context)
	o.unitbar1:SetPoint("TOPLEFT", o.combattext1, "TOPLEFT", 0, 0)
	o.unitbar1:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar1:SetFontSize(SuperMeter_fontSize)
	o.unitbar1:SetParent(o.combatmask1)
	o.unitbar1:SetVisible(false)
	o.unitbar1:SetHeight(Height)

	o.unitbar2 = UI.CreateFrame("Text", "Unit Bar 2", Context)
	o.unitbar2:SetPoint("BOTTOMLEFT", o.unitbar1, "BOTTOMLEFT", 0, Height)
	o.unitbar2:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar2:SetFontSize(SuperMeter_fontSize)
	o.unitbar2:SetParent(o.combatmask1)
	o.unitbar2:SetVisible(false)
	o.unitbar2:SetHeight(Height)

	o.unitbar3 = UI.CreateFrame("Text", "Unit Bar 3", Context)
	o.unitbar3:SetPoint("BOTTOMLEFT", o.unitbar2, "BOTTOMLEFT", 0, Height)
	o.unitbar3:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar3:SetFontSize(SuperMeter_fontSize)
	o.unitbar3:SetParent(o.combatmask1)
	o.unitbar3:SetVisible(false)
	o.unitbar3:SetHeight(Height)

	o.unitbar4 = UI.CreateFrame("Text", "Unit Bar 4", Context)
	o.unitbar4:SetPoint("BOTTOMLEFT", o.unitbar3, "BOTTOMLEFT", 0, Height)
	o.unitbar4:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar4:SetFontSize(SuperMeter_fontSize)
	o.unitbar4:SetParent(o.combatmask1)
	o.unitbar4:SetVisible(false)
	o.unitbar4:SetHeight(Height)

	o.unitbar5 = UI.CreateFrame("Text", "Unit Bar 5", Context)
	o.unitbar5:SetPoint("BOTTOMLEFT", o.unitbar4, "BOTTOMLEFT", 0, Height)
	o.unitbar5:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar5:SetFontSize(SuperMeter_fontSize)
	o.unitbar5:SetParent(o.combatmask1)
	o.unitbar5:SetVisible(false)
	o.unitbar5:SetHeight(Height)

	o.unitbar6 = UI.CreateFrame("Text", "Unit Bar 6", Context)
	o.unitbar6:SetPoint("BOTTOMLEFT", o.unitbar5, "BOTTOMLEFT", 0, Height)
	o.unitbar6:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar6:SetFontSize(SuperMeter_fontSize)
	o.unitbar6:SetParent(o.combatmask1)
	o.unitbar6:SetVisible(false)
	o.unitbar6:SetHeight(Height)

	o.unitbar7 = UI.CreateFrame("Text", "Unit Bar 7", Context)
	o.unitbar7:SetPoint("BOTTOMLEFT", o.unitbar6, "BOTTOMLEFT", 0, Height)
	o.unitbar7:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar7:SetFontSize(SuperMeter_fontSize)
	o.unitbar7:SetParent(o.combatmask1)
	o.unitbar7:SetVisible(false)
	o.unitbar7:SetHeight(Height)

	o.unitbar8 = UI.CreateFrame("Text", "Unit Bar 8", Context)
	o.unitbar8:SetPoint("BOTTOMLEFT", o.unitbar7, "BOTTOMLEFT", 0, Height)
	o.unitbar8:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar8:SetFontSize(SuperMeter_fontSize)
	o.unitbar8:SetParent(o.combatmask1)
	o.unitbar8:SetVisible(false)
	o.unitbar8:SetHeight(Height)

	o.unitbar9 = UI.CreateFrame("Text", "Unit Bar 9", Context)
	o.unitbar9:SetPoint("BOTTOMLEFT", o.unitbar8, "BOTTOMLEFT", 0, Height)
	o.unitbar9:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar9:SetFontSize(SuperMeter_fontSize)
	o.unitbar9:SetParent(o.combatmask1)
	o.unitbar9:SetVisible(false)
	o.unitbar9:SetHeight(Height)

	o.unitbar10 = UI.CreateFrame("Text", "Unit Bar 10", Context)
	o.unitbar10:SetPoint("BOTTOMLEFT", o.unitbar9, "BOTTOMLEFT", 0, Height)
	o.unitbar10:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar10:SetFontSize(SuperMeter_fontSize)
	o.unitbar10:SetParent(o.combatmask1)
	o.unitbar10:SetVisible(false)
	o.unitbar10:SetHeight(Height)

	o.unitbar11 = UI.CreateFrame("Text", "Unit Bar 11", Context)
	o.unitbar11:SetPoint("BOTTOMLEFT", o.unitbar10, "BOTTOMLEFT", 0, Height)
	o.unitbar11:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar11:SetFontSize(SuperMeter_fontSize)
	o.unitbar11:SetParent(o.combatmask1)
	o.unitbar11:SetVisible(false)
	o.unitbar11:SetHeight(Height)

	o.unitbar12 = UI.CreateFrame("Text", "Unit Bar 12", Context)
	o.unitbar12:SetPoint("BOTTOMLEFT", o.unitbar11, "BOTTOMLEFT", 0, Height)
	o.unitbar12:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar12:SetFontSize(SuperMeter_fontSize)
	o.unitbar12:SetParent(o.combatmask1)
	o.unitbar12:SetVisible(false)
	o.unitbar12:SetHeight(Height)

	o.unitbar13 = UI.CreateFrame("Text", "Unit Bar 13", Context)
	o.unitbar13:SetPoint("BOTTOMLEFT", o.unitbar12, "BOTTOMLEFT", 0, Height)
	o.unitbar13:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar13:SetFontSize(SuperMeter_fontSize)
	o.unitbar13:SetParent(o.combatmask1)
	o.unitbar13:SetVisible(false)
	o.unitbar13:SetHeight(Height)

	o.unitbar14 = UI.CreateFrame("Text", "Unit Bar 14", Context)
	o.unitbar14:SetPoint("BOTTOMLEFT", o.unitbar13, "BOTTOMLEFT", 0, Height)
	o.unitbar14:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar14:SetFontSize(SuperMeter_fontSize)
	o.unitbar14:SetParent(o.combatmask1)
	o.unitbar14:SetVisible(false)
	o.unitbar14:SetHeight(Height)

	o.unitbar15 = UI.CreateFrame("Text", "Unit Bar 15", Context)
	o.unitbar15:SetPoint("BOTTOMLEFT", o.unitbar14, "BOTTOMLEFT", 0, Height)
	o.unitbar15:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar15:SetFontSize(SuperMeter_fontSize)
	o.unitbar15:SetParent(o.combatmask1)
	o.unitbar15:SetVisible(false)
	o.unitbar15:SetHeight(Height)

	o.unitbar16 = UI.CreateFrame("Text", "Unit Bar 16", Context)
	o.unitbar16:SetPoint("BOTTOMLEFT", o.unitbar15, "BOTTOMLEFT", 0, Height)
	o.unitbar16:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar16:SetFontSize(SuperMeter_fontSize)
	o.unitbar16:SetParent(o.combatmask1)
	o.unitbar16:SetVisible(false)
	o.unitbar16:SetHeight(Height)

	o.unitbar17 = UI.CreateFrame("Text", "Unit Bar 17", Context)
	o.unitbar17:SetPoint("BOTTOMLEFT", o.unitbar16, "BOTTOMLEFT", 0, Height)
	o.unitbar17:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar17:SetFontSize(SuperMeter_fontSize)
	o.unitbar17:SetParent(o.combatmask1)
	o.unitbar17:SetVisible(false)
	o.unitbar17:SetHeight(Height)

	o.unitbar18 = UI.CreateFrame("Text", "Unit Bar 18", Context)
	o.unitbar18:SetPoint("BOTTOMLEFT", o.unitbar17, "BOTTOMLEFT", 0, Height)
	o.unitbar18:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar18:SetFontSize(SuperMeter_fontSize)
	o.unitbar18:SetParent(o.combatmask1)
	o.unitbar18:SetVisible(false)
	o.unitbar18:SetHeight(Height)

	o.unitbar19 = UI.CreateFrame("Text", "Unit Bar 19", Context)
	o.unitbar19:SetPoint("BOTTOMLEFT", o.unitbar18, "BOTTOMLEFT", 0, Height)
	o.unitbar19:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar19:SetFontSize(SuperMeter_fontSize)
	o.unitbar19:SetParent(o.combatmask1)
	o.unitbar19:SetVisible(false)
	o.unitbar19:SetHeight(Height)

	o.unitbar20 = UI.CreateFrame("Text", "Unit Bar 20", Context)
	o.unitbar20:SetPoint("BOTTOMLEFT", o.unitbar19, "BOTTOMLEFT", 0, Height)
	o.unitbar20:SetFont("SuperMeter", "Swansea.ttf")
	o.unitbar20:SetFontSize(SuperMeter_fontSize)
	o.unitbar20:SetParent(o.combatmask1)
	o.unitbar20:SetVisible(false)
	o.unitbar20:SetHeight(Height)

	o.combattotal1 = UI.CreateFrame("Mask", "Combat Total 1", Context)
	o.combattotal1:SetPoint("BOTTOMCENTER", o.main, "BOTTOMCENTER", -50, -4)
	o.combattotal1:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.combattotal1:SetParent(o.main)
	o.combattotal1:SetHeight(20)

	o.combattotal2 = UI.CreateFrame("Mask", "Combat Total 2", Context)
	o.combattotal2:SetPoint("CENTERRIGHT", o.combattotal1, "CENTERRIGHT", 50, 0)
	o.combattotal2:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.combattotal2:SetParent(o.main)
	o.combattotal2:SetHeight(20)
	o.combattotal2:SetWidth(48)

	o.combattotal3 = UI.CreateFrame("Mask", "Combat Total 3", Context)
	o.combattotal3:SetPoint("CENTERRIGHT", o.combattotal2, "CENTERRIGHT", 50, 0)
	o.combattotal3:SetBackgroundColor(0, 0.4, 0.8, 0.2)
	o.combattotal3:SetParent(o.main)
	o.combattotal3:SetHeight(20)
	o.combattotal3:SetWidth(48)

	o.totaltext1 = UI.CreateFrame("Text", "Combat Total Text 1", Context)
	o.totaltext1:SetPoint("CENTERLEFT", o.combattotal1, "CENTERLEFT", 0, -0.8)
	o.totaltext1:SetFont("SuperMeter", "Swansea.ttf")
	o.totaltext1:SetFontSize(SuperMeter_fontSize)
	o.totaltext1:SetParent(o.combattotal1)

	o.totaltext2 = UI.CreateFrame("Text", "Combat Total Text 2", Context)
	o.totaltext2:SetPoint("TOPCENTER", o.combattotal2, "TOPCENTER", 0, -1.8)
	o.totaltext2:SetFont("SuperMeter", "Swansea.ttf")
	o.totaltext2:SetFontSize(SuperMeter_fontSize)
	o.totaltext2:SetParent(o.combattotal2)
	o.totaltext2:SetWidth(42)

	o.totaltext3 = UI.CreateFrame("Text", "Combat Total Text 3", Context)
	o.totaltext3:SetPoint("TOPCENTER", o.combattotal3, "TOPCENTER", 0, -1.8)
	o.totaltext3:SetFont("SuperMeter", "Swansea.ttf")
	o.totaltext3:SetFontSize(SuperMeter_fontSize)
	o.totaltext3:SetParent(o.combattotal3)
	o.totaltext3:SetWidth(42)

	o.copy = UI.CreateFrame("RiftTextfield", "SuperMeter Copy Text", Context)
	o.copy:SetPoint("TOPLEFT", o.combattotal1, "TOPLEFT", 0, 0.84)
	o.copy:SetParent(o.combattotal1)
	o.copy:SetVisible(false)
	o.copy:SetHeight(20.84)

	o.dlog = UI.CreateFrame("Frame", "Death Log Main", Context)
	o.dlog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX, SuperMeter_logY)
	o.dlog:SetBackgroundColor(0, 0, 0, 0.8)
	o.dlog:SetVisible(false)
	o.dlog:SetWidth(668.88)
	o.dlog:SetHeight(300)

	o.dlogtitlebg = UI.CreateFrame("Frame", "Death Log Title Background", Context)
	o.dlogtitlebg:SetPoint("TOPCENTER", o.dlog, "TOPCENTER", 0, 4)
	o.dlogtitlebg:SetBackgroundColor(0, 0.4, 0.8, 0.28)
	o.dlogtitlebg:SetParent(o.dlog)
	o.dlogtitlebg:SetHeight(48)
	o.dlogtitlebg:SetWidth(660)

	o.dlogtitle = UI.CreateFrame("Text", "Death Log Title", Context)
	o.dlogtitle:SetPoint("TOPCENTER", o.dlog, "TOPCENTER", 0, 4)
	o.dlogtitle:SetFont("SuperMeter", "Swansea.ttf")
	o.dlogtitle:SetParent(o.dlog)
	o.dlogtitle:SetFontSize(16)
	o.dlogtitle:SetHeight(24)
	o.dlogtitle:SetLayer(2)

	o.dlogtitle2 = UI.CreateFrame("Text", "Death Log Secondary Title", Context)
	o.dlogtitle2:SetPoint("TOPCENTER", o.dlogtitle, "TOPCENTER", 0, 24)
	o.dlogtitle2:SetFont("SuperMeter", "Swansea.ttf")
	o.dlogtitle2:SetParent(o.dlog)
	o.dlogtitle2:SetFontSize(14)
	o.dlogtitle2:SetHeight(24)
	o.dlogtitle2:SetLayer(2)

	o.dlogoutbg = UI.CreateFrame("Frame", "Death Log Output Background", Context)
	o.dlogoutbg:SetPoint("TOPCENTER", o.dlog, "TOPCENTER", 0, 56)
	o.dlogoutbg:SetBackgroundColor(0, 0.4, 0.8, 0.08)
	o.dlogoutbg:SetParent(o.dlog)
	o.dlogoutbg:SetHeight(240)
	o.dlogoutbg:SetWidth(660)
	o.dlogoutbg:SetLayer(2)

	o.dlogmask = UI.CreateFrame("Mask", "Death Log Mask", Context)
	o.dlogmask:SetPoint("TOPCENTER", o.dlogoutbg, "TOPCENTER", 0, 6)
	o.dlogmask:SetParent(o.dlog)
	o.dlogmask:SetHeight(228)
	o.dlogmask:SetWidth(660)
	o.dlogmask:SetLayer(2)

	o.dlogtext = UI.CreateFrame("Text", "Death Log Output", Context)
	o.dlogtext:SetFont("SuperMeter", "Swansea.ttf")
	o.dlogtext:SetFontColor(0.88, 0.48, 0.0, 2)
	o.dlogtext:SetParent(o.dlogmask)
	o.dlogtext:SetWordwrap(true)
	o.dlogtext:SetFontSize(14)
	o.dlogtext:SetWidth(628)

	o.dlogslider = UI.CreateFrame("RiftScrollbar", "Death Log Slider", Context)
	o.dlogslider:SetPoint("BOTTOMLEFT", o.dlogmask, "BOTTOMLEFT", 4.8, 0)
	o.dlogslider:SetParent(o.dlogmask)
	o.dlogslider:SetHeight(228)
	o.dlogslider:SetWidth(18)

	o.infotip = UI.CreateFrame("Frame", "Infotip Main", Context)
	o.infotip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -0.48, -120)
	o.infotip:SetBackgroundColor(0, 0, 0, 2)
	o.infotip:SetVisible(false)
	o.infotip:SetLayer(6)

	o.infotiptext = UI.CreateFrame("Text", "Infotip Text", Context)
	o.infotiptext:SetPoint("TOPLEFT", o.infotip, "TOPLEFT", 8.8, 4)
	o.infotiptext:SetFont("SuperMeter", "Swansea.ttf")
	o.infotiptext:SetFontSize(SuperMeter_fontSize)
	o.infotiptext:SetParent(o.infotip)

	o.datatip = UI.CreateFrame("Frame", "Datatip Main", Context)
	o.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -0.48, -120)
	o.datatip:SetBackgroundColor(0, 0, 0, 2)
	o.datatip:SetVisible(false)
	o.datatip:SetLayer(6)

	o.datatiptext = UI.CreateFrame("Text", "Datatip Text", Context)
	o.datatiptext:SetPoint("TOPLEFT", o.datatip, "TOPLEFT", 8.8, 4)
	o.datatiptext:SetFont("SuperMeter", "Swansea.ttf")
	o.datatiptext:SetFontSize(SuperMeter_fontSize)
	o.datatiptext:SetParent(o.datatip)

	o.tipbg = UI.CreateFrame("Frame", "Infotip Main", Context)
	o.tipbg:SetPoint("BOTTOMCENTER", o.infotip, "BOTTOMCENTER", 0, 0.8)
	o.tipbg:SetVisible(false)
	o.tipbg:SetLayer(4)

	function o.main.Event:WheelBack()
		if o.combattext1:GetHeight() > o.combatmask1:GetHeight() then
			o.mainslider:Nudge(o.combatmask1:GetHeight() / SuperMeter_maxSlots)
		end
	end

	function o.main.Event:WheelForward()
		if o.combattext1:GetHeight() > o.combatmask1:GetHeight() then
			o.mainslider:Nudge(-o.combatmask1:GetHeight() / SuperMeter_maxSlots)
		end
	end

	function o.mainslider.Event:ScrollbarChange()
		local offsetY = o.mainslider:GetPosition() - o.mainslider:GetPosition() * 2
		o.combattext1:SetPoint("TOPLEFT", o.combatmask1, "TOPLEFT", 0, offsetY)
		o.combattext2:SetPoint("TOPCENTER", o.combatmask2, "TOPCENTER", 0, offsetY)
		o.combattext3:SetPoint("TOPCENTER", o.combatmask3, "TOPCENTER", 0, offsetY)
	end

	function o.title.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.mouseDown1 = true
		o.state.startX1 = o.main:GetLeft()
		o.state.startY1 = o.main:GetTop()
		o.state.mouseStartX1 = mouse.x
		o.state.mouseStartY1 = mouse.y
		o.main:SetBackgroundColor(0.2, 0.2, 0.2, SuperMeter_alpha - 0.2)
	end

	function o.title.Event:MouseMove()
		if o.state.mouseDown1 then
			o.state.mouseMove1 = true
			o.menus:SetVisible(false)
			local mouse = Inspect.Mouse()
			SuperMeter_x = mouse.x - o.state.mouseStartX1 + o.state.startX1
			SuperMeter_y = mouse.y - o.state.mouseStartY1 + o.state.startY1
			o.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, SuperMeter_y)
		end
		local text = "Super Meter" .. "  v " .. SuperMeter.version .. " \n\nLeft Click And Drag To Move \nMiddle Click Toggles The Window Size \nRight Click Changes Growth Direction "
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.title.Event:LeftUp()
		if o.state.mouseDown1 then
			o.state.mouseDown1 = false
			o.main:SetBackgroundColor(0, 0, 0, SuperMeter_alpha)
			if SuperMeter_growUp and o.state.mouseMove1 then
				local offset_Y = SuperMeter_y
				SuperMeter_y = offset_Y + o.combatmask1:GetHeight() - 5
			end
		end
		o.state.mouseMove1 = false
		SuperMeter.UI.Interface:Update()
	end

	function o.title.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.title.Event:MiddleClick()
		SuperMeter.UI.Interface:SetSize(true)
	end

	function o.title.Event:RightClick()
		if SuperMeter_growUp then
			SuperMeter_growUp = false
		else
			SuperMeter_growUp = true
		end
		o.menus:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.clear.Event:LeftClick()
		o.time:SetText("Time: 00:00")
		SuperMeter:ResetState()
		SuperMeter.Event.Combat()
	end

	function o.clear.Event:MouseMove()
		local text = "Clear Data\nLeft Click To Clear All Collected Data"
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.clear.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.new.Event:LeftClick()
		SuperMeter_split = true
		SuperMeter.Event.Combat()
		SuperMeter.UI.Interface:ChangeEncounter()
	end

	function o.new.Event:MouseMove()
		local text = "New Session\nLeft Click To Start A New Session"
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.new.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.force.Event:LeftClick()
		SuperMeter_forceStart = true
		SuperMeter.Event.Combat()
	end

	function o.force.Event:MouseMove()
		local text = "Force Start Combat\nLeft Click To Force Start Combat"
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.force.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.log.Event:LeftClick()
		if not SuperMeter_logShowing then
			SuperMeter_logShowing = true
		else
			SuperMeter_logShowing = false
		end
		SuperMeter:GetLog()
		o.dlogtitle:SetText("Super Meter Player Death Log")
		o.dlog:SetVisible(not o.dlog:GetVisible())
	end

	function o.log.Event:MouseMove()
		local text = "Player Death Log\nLeft Click To Open The Death Log"
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.log.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.help.Event:LeftClick()
		SuperMeter:GetHelp()
	end

	function o.help.Event:MouseMove()
		local text = "Help File\nLeft Click To Open The Help File"
		SuperMeter.UI.Interface:InfotipShow(text)
	end

	function o.help.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.menu.Event:LeftClick()
		if SuperMeter_maxSlots == 5 then
			o.menus1:SetText("5 Slots")
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0.2, 2)
		elseif SuperMeter_maxSlots == 10 then
			o.menus1:SetText("10 Slots")
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -0.62, 2)
		elseif SuperMeter_maxSlots == 20 then
			o.menus1:SetText("20 Slots")
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0, 2)
		elseif SuperMeter_maxSlots == 5.02 then
			o.menus1:SetText("Self")
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -1.2, 2)
		end
		o.menus2:SetText("< ")
		o.menus4:SetText(" >")
		o.menus:SetBackgroundColor(0, 0, 0, 2)
		o.menus:SetVisible(not o.menus:GetVisible())
		if SuperMeter_growUp then
			o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x + 2, SuperMeter_y - o.combatmask1:GetHeight() + 25)
		else
			o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x + 2, SuperMeter_y + 20)
		end
	end

	function o.menusbg.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.mouseDown2 = true
		o.state.startX2 = o.menus:GetLeft()
		o.state.startY2 = o.menus:GetTop()
		o.state.mouseStartX2 = mouse.x
		o.state.mouseStartY2 = mouse.y
	end

	function o.menusbg.Event:MouseMove()
		if o.state.mouseDown2 then
			local mouse = Inspect.Mouse()
			local menuX = mouse.x - o.state.mouseStartX2 + o.state.startX2
			local menuY = mouse.y - o.state.mouseStartY2 + o.state.startY2
			o.menus:SetPoint("TOPLEFT", UIParent, "TOPLEFT", menuX, menuY)
			o.menus:SetBackgroundColor(0, 0, 0, 0.8)
		end
	end

	function o.menusbg.Event:LeftUp()
		if o.state.mouseDown2 then
			o.state.mouseDown2 = false
		end
	end

	function o.menus1.Event:LeftClick()
		if SuperMeter_maxSlots == 5.02 then
			o.menus1:SetText("5 Slots")
			SuperMeter_maxSlots = 5
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0.2, 2)
		elseif SuperMeter_maxSlots == 5 then
			o.menus1:SetText("10 Slots")
			SuperMeter_maxSlots = 10
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -0.62, 2)
		elseif SuperMeter_maxSlots == 10 then
			o.menus1:SetText("20 Slots")
			SuperMeter_maxSlots = 20
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", 0, 2)
		elseif SuperMeter_maxSlots == 20 then
			o.menus1:SetText("Self")
			SuperMeter_maxSlots = 5.02
			o.menus1:SetPoint("TOPCENTER", o.menusbg, "TOPCENTER", -1.2, 2)
		end
		SuperMeter.UI.Interface:Update()
	end

	function o.menus2.Event:LeftClick()
		if SuperMeter.state.encounterOffset < #SuperMeter.state.encounters - 1 then
			SuperMeter.state.encounterOffset = SuperMeter.state.encounterOffset + 1
			SuperMeter.UI.Interface:ChangeEncounter()
		end
	end

	function o.menus4.Event:LeftClick()
		if SuperMeter.state.encounterOffset > 0 then
			SuperMeter.state.encounterOffset = SuperMeter.state.encounterOffset - 1
			SuperMeter.UI.Interface:ChangeEncounter()
		end
	end

	function o.relation.Event:LeftClick()
		local side = SuperMeter_side
		if side == "Allies" then
			SuperMeter_side = "Enemies"
		end
		if side == "Enemies" then
			SuperMeter_side = "Allies"
		end
		SuperMeter.UI.Interface:Update()
		SuperMeter.UI.Interface:Relation()
	end

	function o.mode1.Event:LeftClick()
		SuperMeter_mode = SuperMeter_mode1
		SuperMeter.UI.Interface:Update()
	end

	function o.mode1.Event:RightClick()
		local sortTable = {}
		local encounter = encounter()
		
		o.modeselect:SetVisible(not o.modeselect:GetVisible())
		o.modeselectbg:SetVisible(not o.modeselectbg:GetVisible())
		
		if SuperMeter_side == "Allies" then
			sortTable = encounter.allies
		else
			sortTable = encounter.enemies
		end
		if o.modeselect:GetVisible() then
			SuperMeter_mode1Change = true
		else
			SuperMeter_mode1Change = false
			SuperMeter_mode2Change = false
		end
		if SuperMeter_growUp and o.combatmask1:GetHeight() < 12 * (o.combattext1:GetHeight() / #sortTable) then
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 0, -294)
		else
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 0, 24)
		end
		sortTable = {}
	end

	function o.mode1.Event:MouseMove()
		SuperMeter.UI.Interface:ModeDescription(true, false, false)
	end

	function o.mode1.Event:MouseOut()
		SuperMeter_modeDesc = false
		if SuperMeter_value then
			o.totaltext1:SetText("Total:")
		else
			o.totaltext1:SetText("")
		end
	end

	function o.mode2.Event:LeftClick()
		SuperMeter_mode = SuperMeter_mode2
		SuperMeter.UI.Interface:Update()
	end

	function o.mode2.Event:RightClick()
		local sortTable = {}
		local encounter = encounter()
		
		o.modeselect:SetVisible(not o.modeselect:GetVisible())
		o.modeselectbg:SetVisible(not o.modeselectbg:GetVisible())
		
		if SuperMeter_side == "Allies" then
			sortTable = encounter.allies
		else
			sortTable = encounter.enemies
		end
		if o.modeselect:GetVisible() then
			SuperMeter_mode2Change = true
		else
			SuperMeter_mode1Change = false
			SuperMeter_mode2Change = false
		end
		if SuperMeter_growUp and o.combatmask1:GetHeight() < 12 * (o.combattext1:GetHeight() / #sortTable) then
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 50, -294)
		else
			o.modeselectbg:SetPoint("TOPRIGHT", o.mode1, "TOPRIGHT", 50, 24)
		end
		sortTable = {}
	end

	function o.mode2.Event:MouseMove()
		SuperMeter.UI.Interface:ModeDescription(false, true, false)
	end

	function o.mode2.Event:MouseOut()
		SuperMeter_modeDesc = false
		if SuperMeter_value then
			o.totaltext1:SetText("Total:")
		else
			o.totaltext1:SetText("")
		end
	end

	function o.mode1select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DPS"
			end
			SuperMeter_mode1 = "DPS"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DPS"
			end
			SuperMeter_mode2 = "DPS"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode2select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DMG"
			end
			SuperMeter_mode1 = "DMG"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DMG"
			end
			SuperMeter_mode2 = "DMG"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode3select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DTN"
			end
			SuperMeter_mode1 = "DTN"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DTN"
			end
			SuperMeter_mode2 = "DTN"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode4select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "OKL"
			end
			SuperMeter_mode1 = "OKL"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "OKL"
			end
			SuperMeter_mode2 = "OKL"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode5select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "HPS"
			end
			SuperMeter_mode1 = "HPS"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "HPS"
			end
			SuperMeter_mode2 = "HPS"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode6select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "HLG"
			end
			SuperMeter_mode1 = "HLG"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "HLG"
			end
			SuperMeter_mode2 = "HLG"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode7select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "HTN"
			end
			SuperMeter_mode1 = "HTN"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "HTN"
			end
			SuperMeter_mode2 = "HTN"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode8select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "OPS"
			end
			SuperMeter_mode1 = "OPS"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "OPS"
			end
			SuperMeter_mode2 = "OPS"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode9select.Event:LeftClick()
		if SuperMeter_mode1Change then
			SuperMeter_mode1 = "OHG"
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "OHG"
			end
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "OHG"
			end
			SuperMeter_mode2 = "OHG"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode10select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "ASB"
			end
			SuperMeter_mode1 = "ASB"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "ASB"
			end
			SuperMeter_mode2 = "ASB"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode11select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "AVD"
			end
			SuperMeter_mode1 = "AVD"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "AVD"
			end
			SuperMeter_mode2 = "AVD"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode12select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "BLK"
			end
			SuperMeter_mode1 = "BLK"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "BLK"
			end
			SuperMeter_mode2 = "BLK"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode13select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "DFT"
			end
			SuperMeter_mode1 = "DFT"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "DFT"
			end
			SuperMeter_mode2 = "DFT"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.mode14select.Event:LeftClick()
		if SuperMeter_mode1Change then
			if SuperMeter_mode == SuperMeter_mode1 then
				SuperMeter_mode = "MSD"
			end
			SuperMeter_mode1 = "MSD"
			o.mode1:SetText(SuperMeter_mode1)
			SuperMeter_mode1Change = false
		end
		if SuperMeter_mode2Change then
			if SuperMeter_mode == SuperMeter_mode2 then
				SuperMeter_mode = "MSD"
			end
			SuperMeter_mode2 = "MSD"
			o.mode2:SetText(SuperMeter_mode2)
			SuperMeter_mode2Change = false
		end
		o.modeselect:SetVisible(false)
		o.modeselectbg:SetVisible(false)
		SuperMeter.UI.Interface:Update()
	end

	function o.combatmask1.Event:LeftClick()
		if encounter().allies[1] then
			local unit = SuperMeter.UI.Interface:GetUnit()
			if unit then
				if unit.combatlog[1] then
					o.log.Event:LeftClick()
					SuperMeter:GetLog(unit)
				end
			end
		end
	end

	function o.combatmask1.Event:RightClick()
		if SuperMeter_display == "None" then
			SuperMeter_display = "Bars"
			o.combattext1:SetVisible(true)
		elseif SuperMeter_display == "Bars" then
			SuperMeter_display = "Calling"
			o.combattext1:SetVisible(false)
		elseif SuperMeter_display == "Calling" then
			SuperMeter_display = "None"
			o.combattext1:SetVisible(true)
		end
		SuperMeter.UI.Interface:FrameSort()
	end

	function o.mode1select.Event:MouseIn()
		o.mode1select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode2select.Event:MouseIn()
		o.mode2select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode3select.Event:MouseIn()
		o.mode3select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode4select.Event:MouseIn()
		o.mode4select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode5select.Event:MouseIn()
		o.mode5select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode6select.Event:MouseIn()
		o.mode6select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode7select.Event:MouseIn()
		o.mode7select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode8select.Event:MouseIn()
		o.mode8select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode9select.Event:MouseIn()
		o.mode9select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode10select.Event:MouseIn()
		o.mode10select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode11select.Event:MouseIn()
		o.mode11select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode12select.Event:MouseIn()
		o.mode12select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode13select.Event:MouseIn()
		o.mode13select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode14select.Event:MouseIn()
		o.mode14select:SetFontColor(0, 0.4, 0.8, 0.6)
	end

	function o.mode1select.Event:MouseOut()
		o.mode1select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode2select.Event:MouseOut()
		o.mode2select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode3select.Event:MouseOut()
		o.mode3select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode4select.Event:MouseOut()
		o.mode4select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode5select.Event:MouseOut()
		o.mode5select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode6select.Event:MouseOut()
		o.mode6select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode7select.Event:MouseOut()
		o.mode7select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode8select.Event:MouseOut()
		o.mode8select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode9select.Event:MouseOut()
		o.mode9select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode10select.Event:MouseOut()
		o.mode10select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode11select.Event:MouseOut()
		o.mode11select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode12select.Event:MouseOut()
		o.mode12select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode13select.Event:MouseOut()
		o.mode13select:SetFontColor(2, 2, 2, 2)
	end

	function o.mode14select.Event:MouseOut()
		o.mode14select:SetFontColor(2, 2, 2, 2)
	end

	function o.combatmask1.Event:MouseMove()
		if encounter().allies[1] then
			local text = nil
			local unit = SuperMeter.UI.Interface:GetUnit()
			if unit and unit.name then
				if unit.combatlog[1] then
					text = "Left Click To View " .. unit.name .. "'s Combat Log "
				else
					SuperMeter.UI.Interface:InfotipHide()
				end
				if text then
					SuperMeter.UI.Interface:InfotipShow(text)
				end
			else
				SuperMeter.UI.Interface:InfotipHide()
			end
		end
	end

	function o.combatmask1.Event:MouseOut()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.combattext2.Event:MouseMove()
		SuperMeter_ModeRequest = SuperMeter_mode1
		SuperMeter.UI.Interface:AbilitySort()
		SuperMeter.UI.Interface:TipColours(true)
	end

	function o.combattext2.Event:MouseOut()
		SuperMeter.UI.Interface:TipColours()
		SuperMeter.UI.Interface:DatatipHide()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.combattext3.Event:MouseMove()
		SuperMeter_ModeRequest = SuperMeter_mode2
		SuperMeter.UI.Interface:AbilitySort()
		SuperMeter.UI.Interface:TipColours(true)
	end

	function o.combattext3.Event:MouseOut()
		SuperMeter.UI.Interface:TipColours()
		SuperMeter.UI.Interface:DatatipHide()
		SuperMeter.UI.Interface:InfotipHide()
	end

	function o.combattotal2.Event:LeftClick()
		o.copy:SetVisible(not o.copy:GetVisible())
		o.totaltext1:SetVisible(not o.copy:GetVisible())
		SuperMeter.UI.Interface:FrameSort(true, true, false)
	end

	function o.combattotal3.Event:LeftClick()
		o.copy:SetVisible(not o.copy:GetVisible())
		o.totaltext1:SetVisible(not o.copy:GetVisible())
		SuperMeter.UI.Interface:FrameSort(true, false, true)
	end

	function o.copy.Event:KeyUp()
		o.copy:SetText("")
		o.copy:SetVisible(false)
		o.copy:SetKeyFocus(false)
		o.totaltext1:SetVisible(true)
	end

	function o.dlogtitle.Event:LeftDown()
		local mouse = Inspect.Mouse()
		o.state.mouseDown3 = true
		o.state.startX3 = o.dlog:GetLeft()
		o.state.startY3 = o.dlog:GetTop()
		o.state.mouseStartX3 = mouse.x
		o.state.mouseStartY3 = mouse.y
		o.dlog:SetBackgroundColor(0.2, 0.2, 0.2, 0.6)
	end

	function o.dlogtitle.Event:MouseMove()
		if o.state.mouseDown3 then
			local mouse = Inspect.Mouse()
			SuperMeter_logX = mouse.x - o.state.mouseStartX3 + o.state.startX3
			SuperMeter_logY = mouse.y - o.state.mouseStartY3 + o.state.startY3
			o.dlog:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_logX, SuperMeter_logY)
		end
	end

	function o.dlogtitle.Event:LeftUp()
		if o.state.mouseDown3 then
			o.state.mouseDown3 = false
			o.dlog:SetBackgroundColor(0, 0, 0, 0.8)
		end
	end

	function o.dlogtitle2.Event:LeftClick()
		SuperMeter:GetLog()
	end

	function o.dlog.Event:LeftClick()
		o.dlogslider:Nudge(-o.dlogtext:GetHeight())
	end

	function o.dlog.Event:RightClick()
		o.dlogslider:Nudge(o.dlogtext:GetHeight())
	end

	function o.dlog.Event:WheelBack()
		if o.dlogtext:GetHeight() > o.dlogmask:GetHeight() then
			o.dlogslider:NudgeDown()
		end
	end

	function o.dlog.Event:WheelForward()
		if o.dlogtext:GetHeight() > o.dlogmask:GetHeight() then
			o.dlogslider:NudgeUp()
		end
	end

	function o.dlogslider.Event:ScrollbarChange()
		local offsetY = o.dlogslider:GetPosition() - o.dlogslider:GetPosition() * 2
		o.dlogtext:SetPoint("TOPRIGHT", o.dlogmask, "TOPRIGHT", -4, offsetY)
	end

	return o
end

function Interface:Toggle()
	self.main:SetVisible(not self.main:GetVisible())
end

function Interface:SetTime(returnTime)
	local encounter = encounter()
	local time = 0

	if SuperMeter_inCombat then
		time = Inspect.Time.Frame() - encounter.startCombat
	end
	if SuperMeter.state.encounterOffset > 0 or not SuperMeter_inCombat then
		time = encounter.combatTime
	end

	local text = "Time: " .. SuperMeter.Util.FormatTime(time)
	self.time:SetText(text)

	if returnTime then
		return time
	end
end

function Interface:Relation()
	if SuperMeter_side == "Allies" then
		self.relation:SetText("Allies")
		self.combatmask1:SetBackgroundColor(0, 0.8, 0.2, 0.08)
		self.combatmask2:SetBackgroundColor(0, 0.8, 0.2, 0.08)
		self.combatmask3:SetBackgroundColor(0, 0.8, 0.2, 0.08)
	end
	if SuperMeter_side == "Enemies" then
		self.relation:SetText("Enemies")
		self.combatmask1:SetBackgroundColor(0.8, 0, 0, 0.08)
		self.combatmask2:SetBackgroundColor(0.8, 0, 0, 0.08)
		self.combatmask3:SetBackgroundColor(0.8, 0, 0, 0.08)
	end
	self:TipColours()
	self:Update()
end

function Interface:SetSize(change)
	if change then
		if SuperMeter_fontSize == 14 then
			if SuperMeter_width == 268 then 
				SuperMeter_width = 288
			elseif SuperMeter_width == 288 then
				SuperMeter_width = 268
			end
		else
			if SuperMeter_width == 268 then 
				SuperMeter_width = 256
			elseif SuperMeter_width == 256 then
				SuperMeter_width = 268
			end
		end
	end

	self:Update()
	self.main:SetWidth(SuperMeter_width)
	self.copy:SetWidth(SuperMeter_width - 108)
	self.combatmask1:SetWidth(SuperMeter_width - 108)
	self.combattotal1:SetWidth(SuperMeter_width - 108)
end

function Interface:Display()
	if SuperMeter_display == "None" then
		self.combattext1:SetVisible(true)
	elseif SuperMeter_display == "Bars" then
		self.combattext1:SetVisible(true)
	elseif SuperMeter_display == "Calling" then
		self.combattext1:SetVisible(false)
	end
end

function Interface:ResetText()
	self.copy:SetText("")
	self.combattext1:SetText("")
	self.combattext2:SetText("")
	self.combattext3:SetText("")
	self.totaltext1:SetText("")
	self.totaltext2:SetText("")
	self.totaltext3:SetText("")
	self.copy:SetVisible(false)
	self.copy:SetKeyFocus(false)
	self.totaltext1:SetVisible(not self.copy:GetVisible())
end

function Interface:CombatText(nameText, mode1Text, mode2Text)
	if not self.state.mouseDown1 then
		self.combattext1:SetText(nameText)
		self.combattext2:SetText(mode1Text)
		self.combattext3:SetText(mode2Text)
		
		local height = self.combattext1:GetHeight()
		local offset_y = SuperMeter_y
		local max = 0
		
		if SuperMeter_fontSize == 14 then
			max = SuperMeter_maxSlots * 23.6
		else
			max = SuperMeter_maxSlots * 21.88
		end
		
		if height > max then
			height = max
		end
		
		if SuperMeter_growUp then
			offset_y = SuperMeter_y - height + 5
		end
		
		self.main:SetHeight(height + 76)
		self.combatmask1:SetHeight(height)
		self.combatmask2:SetHeight(height)
		self.combatmask3:SetHeight(height)
		self.main:SetPoint("TOPLEFT", UIParent, "TOPLEFT", SuperMeter_x, offset_y)
		self.mainslider:SetRange(0, self.combattext1:GetHeight() - self.combatmask1:GetHeight() + 0.8)
	end
end

function Interface:CombatTotal(text1, text2)
	if not self.state.mouseDown1 then
		local total1 = SuperMeter.Util.FormatNumber(text1)
		local total2 = SuperMeter.Util.FormatNumber(text2)
		
		if text1 > 0 or text2 > 0 then
			self.totaltext2:SetText(total1)
			self.totaltext3:SetText(total2)
			if not SuperMeter_modeDesc then
				self.totaltext1:SetText("Total:")
			end
		else
			if not SuperMeter_modeDesc then
				self:ResetText()
			end
		end
	end
end

function Interface:DeathLog(text)
	self.dlogtext:SetText(text)

	local doHeight = self.dlogtext:GetHeight()
	local dmHeight = self.dlogmask:GetHeight()

	if doHeight > dmHeight then
		self.dlogslider:SetRange(0, doHeight - dmHeight)
		self.dlogslider:SetVisible(true)
		self.dlogslider:Nudge(doHeight)
	else
		self.dlogslider:SetRange(0, 0)
		self.dlogslider:SetVisible(false)
		self.dlogtext:SetPoint("TOPRIGHT", self.dlogmask, "TOPRIGHT", -4, 0)
	end
end

function Interface:DeathLogUnit(text)
	self.dlogtitle2:SetText(text)
end

function Interface:DeathLogHide()
	self.log:SetVisible(not self.log:GetVisible())
	self.help:SetVisible(not self.help:GetVisible())
end

function Interface:ModeDescription(mode1, mode2)
	local Desc = nil
	local Mode = nil
	
	if mode1 then
		Mode = SuperMeter_mode1
	end
	if mode2 then
		Mode = SuperMeter_mode2
	end

	if Mode == "DPS" then
		Desc = "Damage Per Second"
	elseif Mode == "DMG" then
		Desc = "Damage"
	elseif Mode == "HPS" then
		Desc = "Healing Per Second"
	elseif Mode == "HLG" then
		Desc = "Healing"
	elseif Mode == "OPS" then
		Desc = "Overhealing Per Second"
	elseif Mode == "OHG" then
		Desc = "Overhealing"
	elseif Mode == "OKL" then
		Desc = "Overkill"
	elseif Mode == "DTN" then
		Desc = "Damage Taken"
	elseif Mode == "HTN" then
		Desc = "Healing Taken"
	elseif Mode == "ASB" then
		Desc = "Absorbed Damage"
	elseif Mode == "AVD" then
		Desc = "Avoided Damage"
	elseif Mode == "BLK" then
		Desc = "Blocked Damage"
	elseif Mode == "DFT" then
		Desc = "Deflected Damage"
	elseif Mode == "MSD" then
		Desc = "Missed Damage"
	end
	
	if Desc then
		SuperMeter_modeDesc = true
		self.totaltext1:SetText(Desc)
	end
end

function Interface:ChangeEncounter()
	if SuperMeter.state.encounterIndex == 0 then
		self.menus3:SetText("00 - 00")
	elseif #SuperMeter.state.encounters < 10 then
		self.menus3:SetText(string.format("%2d - %d ", SuperMeter.state.encounterIndex - SuperMeter.state.encounterOffset, #SuperMeter.state.encounters))
	else
		self.menus3:SetText(string.format("%2d - %d", SuperMeter.state.encounterIndex - SuperMeter.state.encounterOffset, #SuperMeter.state.encounters))
	end
	SuperMeter:GetLog()
	self:Update()
end

function Interface:DataSort()
	local encounter = encounter()
	local time = self:SetTime(true)
	local mode = SuperMeter_mode
	local sortTable = {}

	encounter.allies = {}
	encounter.enemies = {}

	for k,v in pairs (encounter.units) do
		local unit = encounter.units[k]
		
		if SuperMeter_maxSlots == 5.02 then
			if unit.relation == "friendly" then
				local player = Inspect.Unit.Detail("player")
				if unit.name == player.name then
					unit = encounter.units[k]
				else
					unit = nil
				end
			end
		end
		
		if unit then
			local data = {
				name = unit.name,
				calling = unit.calling,
				mode1 = unit.damage / time,
				mode2 = unit.damage,
				mode3 = unit.healing / time,
				mode4 = unit.healing,
				mode5 = unit.overHealing / time,
				mode6 = unit.overHealing,
				mode7 = unit.overKill,
				mode8 = unit.damageTaken,
				mode9 = unit.healingTaken,
				mode10 = unit.damageAbsorbed,
				mode11 = unit.damageAvoided,
				mode12 = unit.damageBlocked,
				mode13 = unit.damageDeflected,
				mode14 = unit.damageMissed,
			}
			
			if unit.relation == "friendly" then
				if unit.player then
					table.insert(encounter.allies, data)
				end
			else
				if unit.name then
					table.insert(encounter.enemies, data)
				end
			end
		end
	end

	if SuperMeter_side == "Allies" then
		sortTable = encounter.allies
	else
		sortTable = encounter.enemies
	end

	if mode == "DPS" or mode == "DMG" then
		table.sort(sortTable, function (a,b) return a.mode1 > b.mode1 end)
	elseif mode == "HPS" or mode == "HLG" then
		table.sort(sortTable, function (a,b) return a.mode3 > b.mode3 end)
	elseif mode == "OPS" or mode == "OHG" then
		table.sort(sortTable, function (a,b) return a.mode5 > b.mode5 end)
	elseif mode == "OKL" then
		table.sort(sortTable, function (a,b) return a.mode7 > b.mode7 end)
	elseif mode == "DTN" then
		table.sort(sortTable, function (a,b) return a.mode8 > b.mode8 end)
	elseif mode == "HTN" then
		table.sort(sortTable, function (a,b) return a.mode9 > b.mode9 end)
	elseif mode == "ASB" then
		table.sort(sortTable, function (a,b) return a.mode10 > b.mode10 end)
	elseif mode == "AVD" then
		table.sort(sortTable, function (a,b) return a.mode11 > b.mode11 end)
	elseif mode == "BLK" then
		table.sort(sortTable, function (a,b) return a.mode12 > b.mode12 end)
	elseif mode == "DFT" then
		table.sort(sortTable, function (a,b) return a.mode13 > b.mode13 end)
	elseif mode == "MSD" then
		table.sort(sortTable, function (a,b) return a.mode14 > b.mode14 end)
	end

	if #sortTable > 20 then
		for i = 21, #sortTable do
			sortTable[i] = nil
		end
	end

	sortTable = {}
end

function Interface:AbilitySort()
	local encounter = encounter()
	local mode = SuperMeter_ModeRequest
	local time = self:SetTime(true)
	local unit = self:GetUnit()
	local calling = ""

	for k,v in pairs (encounter.units) do
		if unit and unit.name == encounter.units[k].name then
			local unit = encounter.units[k]
			
			if unit.level == "??" then calling = "[ Boss ] " end
			
			if unit.calling then
				if unit.calling == "cleric" then
					calling = "[ Cleric ] "
				elseif v.calling == "mage" then
					calling = "[ Mage ] "
				elseif v.calling == "rogue" then
					calling = "[ Rogue ] "
				elseif v.calling == "warrior" then
					calling = "[ Warrior ] "
				end
			end
			
			if (mode == "DPS" and unit.damage <= 0) or (mode == "DMG" and unit.damage <= 0)
			or (mode == "HPS" and unit.healing <= 0) or (mode == "HLG" and unit.healing <= 0)
			or (mode == "OKL" and unit.overKill <= 0) or (mode == "OPS" and unit.overHealing <= 0)
			or (mode == "DTN" and unit.damageTaken <= 0) or (mode == "HTN" and unit.healingTaken <= 0)
			or (mode == "ASB" and unit.damageAbsorbed <= 0) or (mode == "AVD" and unit.damageAvoided <= 0)
			or (mode == "BLK" and unit.damageBlocked <= 0) or (mode == "DFT" and unit.damageDeflected <= 0)
			or (mode == "MSD" and unit.damageMissed <= 0) then self:InfotipHide() self:DatatipHide() return end
			
			local abilities = {}
			
			for k,_ in pairs(unit.abilities) do
				table.insert(abilities, k)
			end
			
			if mode == "DPS" or mode == "DMG" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damage > unit.abilities[b].damage end)
			elseif mode == "HPS" or mode == "HLG" then
				table.sort(abilities, function(a, b) return unit.abilities[a].healing > unit.abilities[b].healing end)
			elseif mode == "OPS" or mode == "OHG" then
				table.sort(abilities, function(a, b) return unit.abilities[a].overHealing > unit.abilities[b].overHealing end)
			elseif mode == "OKL" then
				table.sort(abilities, function(a, b) return unit.abilities[a].overKill > unit.abilities[b].overKill end)
			elseif mode == "DTN" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageTaken > unit.abilities[b].damageTaken end)
			elseif mode == "HTN" then
				table.sort(abilities, function(a, b) return unit.abilities[a].healingTaken > unit.abilities[b].healingTaken end)
			elseif mode == "ASB" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageAbsorbed > unit.abilities[b].damageAbsorbed end)
			elseif mode == "AVD" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageAvoided > unit.abilities[b].damageAvoided end)
			elseif mode == "BLK" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageBlocked > unit.abilities[b].damageBlocked end)
			elseif mode == "DFT" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageDeflected > unit.abilities[b].damageDeflected end)
			elseif mode == "MSD" then
				table.sort(abilities, function(a, b) return unit.abilities[a].damageMissed > unit.abilities[b].damageMissed end)
			end
			
			if #abilities > 28 then
				for i = 29, #abilities do
					abilities[i] = nil
				end
			end
			
			local info = unit.name .. "'s " .. calling .. mode .. ":\n\n"
			local title = unit.name .. "'s "  .. calling .. "Combat Data:\n\n"
			
			unit.damageOutput = unit.damageOut + unit.damageMissed
			unit.DCrit = unit.damageOutput - unit.damageNonCritical
			unit.HCrit =  unit.healingOut - unit.healingNonCritical
			unit.OHCrit = unit.overHealingOut - unit.overhealingNonCritical
			unit.OKCrit = unit.overKillOut - unit.overKillNonCritical
			unit.DTCrit = unit.damageIn - unit.damageTakenNonCritical
			unit.HTCrit = unit.healingIn - unit.healingTakenNonCritical
			
			DTotal = (unit.damageCritical / unit.DCrit) * 100
			HTotal = (unit.healingCritical / unit.HCrit) * 100
			OHTotal = (unit.overHealingCritical / unit.OHCrit) * 100
			OKTotal = (unit.overKillCritical / unit.OKCrit) * 100
			DTTotal = (unit.damageTakenCritical / unit.DTCrit)  * 100
			HTTotal = (unit.healingTakenCritical / unit.HTCrit) * 100
			DABTotal = (unit.damageAbsorbIn / unit.damageIn) * 100
			DAVTotal = (unit.damageAvoided / unit.damageAvoidIn) * 100
			DBTotal = (unit.damageBlockIn / unit.damageMitigable) * 100
			DDTotal = (unit.damageDeflectIn / unit.damageMitigable) * 100
			DMTotal = (unit.damageMissed / unit.damageOutput) * 100
			
			for _,name in pairs(abilities) do
				if mode == "DPS" or mode == "DMG" then
					value = unit.abilities[name].damage
					total = unit.damage
					if DTotal <= 0 or unit.DCrit <= 0 then data = title .. unit.damageOutput .. " Attacks " .. unit.damageCritical .. " Criticals: 0.00%"
					else data = title .. unit.damageOutput .. " Attacks " .. unit.damageCritical .. " Criticals: " .. string.format("%.2f%%\n", DTotal) end
				elseif mode == "HPS" or mode == "HLG" then
					value = unit.abilities[name].healing
					total = unit.healing
					if HTotal <= 0 or unit.HCrit <= 0 then data = title .. unit.healingOut .. " Heals " .. unit.healingCritical .. " Criticals: 0.00%"
					else data = title .. unit.healingOut .. " Heals " .. unit.healingCritical .. " Criticals: " .. string.format("%.2f%%\n", HTotal) end
				elseif mode == "OPS" or mode == "OHG" then
					value = unit.abilities[name].overHealing
					total = unit.overHealing
					if OHTotal <= 0 or unit.OHCrit <= 0 then data = title .. unit.overHealingOut .. " Heals " .. unit.overHealingCritical .. " Criticals: 0.00%"
					else data = title .. unit.overHealingOut .. " Heals " .. unit.overHealingCritical .. " Criticals: " .. string.format("%.2f%%\n", OHTotal) end
				elseif mode == "OKL" then
					value = unit.abilities[name].overKill
					total = unit.overKill
					if OKTotal <= 0 or unit.OKCrit <= 0 then data = title .. unit.overKillOut .. " Attacks " .. unit.overKillCritical .. " Criticals: 0.00%"
					else data = title .. unit.overKillOut .. " Attacks " .. unit.overKillCritical .. " Criticals: " .. string.format("%.2f%%\n", OKTotal) end
				elseif mode == "DTN" then
					value = unit.abilities[name].damageTaken
					total = unit.damageTaken
					if DTTotal <= 0 or unit.DTCrit <= 0 then data = title .. unit.damageIn .. " Attacks " .. unit.damageTakenCritical .. " Criticals: 0.00%"
					else data = title .. unit.damageIn .. " Attacks " .. unit.damageTakenCritical .. " Criticals: " .. string.format("%.2f%%\n", DTTotal) end
				elseif mode == "HTN" then
					value = unit.abilities[name].healingTaken
					total = unit.healingTaken
					if HTTotal <= 0 or unit.HTCrit <= 0 then data = title .. unit.healingIn .. " Heals " .. unit.healingTakenCritical .. " Criticals: 0.00%"
					else data = title .. unit.healingIn .. " Heals " .. unit.healingTakenCritical .. " Criticals: " .. string.format("%.2f%%\n", HTTotal) end
				elseif mode == "ASB" then
					value = unit.abilities[name].damageAbsorbed 
					total = unit.damageAbsorbed
					if DABTotal <= 0 or unit.damageAbsorbIn <= 0 then data = title .. unit.damageIn .. " Attacks " .. unit.damageAbsorbIn .. " Absorbed: 0.00%"
					else data = title .. unit.damageIn .. " Attacks " .. unit.damageAbsorbIn .. " Absorbed: " .. string.format("%.2f%%\n", DABTotal) end
				elseif mode == "AVD" then
					value = unit.abilities[name].damageAvoided 
					total = unit.damageAvoided
					if DAVTotal <= 0 or unit.damageAvoided <= 0 then data = title .. unit.damageAvoidIn .. " Avoidable " .. unit.damageAvoided .. " Avoided: 0.00%"
					else data = title .. unit.damageAvoidIn .. " Avoidable " .. unit.damageAvoided .. " Avoided: " .. string.format("%.2f%%\n", DAVTotal) end
				elseif mode == "BLK" then
					value = unit.abilities[name].damageBlocked 
					total = unit.damageBlocked
					if DBTotal <= 0 or unit.damageBlockIn <= 0 then data = title .. unit.damageMitigable .. " Blockable " .. unit.damageBlockIn .. " Blocked: 0.00%"
					else data = title .. unit.damageMitigable .. " Blockable " .. unit.damageBlockIn .. " Blocked: " .. string.format("%.2f%%\n", DBTotal) end
				elseif mode == "DFT" then
					value = unit.abilities[name].damageDeflected 
					total = unit.damageDeflected
					if DDTotal <= 0 or unit.damageDeflectIn <= 0 then data = title .. unit.damageMitigable .. " Deflectable " .. unit.damageDeflectIn .. " Deflected: 0.00%"
					else data = title .. unit.damageMitigable .. " Deflectable " .. unit.damageDeflectIn .. " Deflected: " .. string.format("%.2f%%\n", DDTotal) end
				elseif mode == "MSD" then
					value = unit.abilities[name].damageMissed
					total = unit.damageMissed
					if DMTotal <= 0 or unit.damageMissed <= 0 then data = title .. unit.damageOutput .. " Attacks " .. unit.damageMissed .. " Missed: 0.00%"
					else data = title .. unit.damageOutput .. " Attacks " .. unit.damageMissed .. " Missed: " .. string.format("%.2f%%\n", DMTotal) end
				end
				if value > 0 then
					local out = value
					if mode == "DPS" or mode == "HPS" or mode == "OPS" then out = SuperMeter.Util.FormatNumber(value / time) end
					info = info .. string.format("[ " .. out .. " ] [ %.2f%% %s\n", (value / total) * 100, "]  " .. name .. " ")
				end
				self:InfotipShow(info)
				self:DatatipShow(data)
			end
		end
		SuperMeter_ModeRequest = nil
	end
end

function Interface:FrameSort(export, export1, export2)
	local encounter = encounter()
	local main = SuperMeter_mode
	local mode1 = SuperMeter_mode1
	local mode2 = SuperMeter_mode2
	local width = SuperMeter_width - 108
	local colourTable = {}
	local sortTable = {}

	local mode = ""
	local Mode1 = 0
	local Mode2 = 0
	local exportText1 = ""
	local exportText2 = ""
	local nameText = ""
	local mode1Text = ""
	local mode2Text = ""
	local total = 0
	local total1 = 0
	local total2 = 0

	if SuperMeter_side == "Allies" then
		sortTable = encounter.allies
	else
		sortTable = encounter.enemies
	end

	if main == "DPS" then
		mode = "mode1"
	elseif main == "DMG" then
		mode = "mode2"
	elseif main == "HPS" then
		mode = "mode3"
	elseif main == "HLG" then
		mode = "mode4"
	elseif main == "OPS" then
		mode = "mode5"
	elseif main == "OHG" then
		mode = "mode6"
	elseif main == "OKL" then
		mode = "mode7"
	elseif main == "DTN" then
		mode = "mode8"
	elseif main == "HTN" then
		mode = "mode9"
	elseif main == "ASB" then
		mode = "mode10"
	elseif mode == "AVD" then
		mode = "mode11"
	elseif mode == "BLK" then
		mode = "mode12"
	elseif main == "DFT" then
		mode = "mode13"
	elseif main == "MSD" then
		mode = "mode14"
	end

	for k,v in pairs (sortTable) do
		if sortTable[1] then
			if mode1 == "DPS" then
				Mode1 = v.mode1
			elseif mode1 == "DMG" then
				Mode1 = v.mode2
			elseif mode1 == "HPS" then
				Mode1 = v.mode3
			elseif mode1 == "HLG" then
				Mode1 = v.mode4
			elseif mode1 == "OPS" then
				Mode1 = v.mode5
			elseif mode1 == "OHG" then
				Mode1 = v.mode6
			elseif mode1 == "OKL" then
				Mode1 = v.mode7
			elseif mode1 == "DTN" then
				Mode1 = v.mode8
			elseif mode1 == "HTN" then
				Mode1 = v.mode9
			elseif mode1 == "ASB" then
				Mode1 = v.mode10
			elseif mode1 == "AVD" then
				Mode1 = v.mode11
			elseif mode1 == "BLK" then
				Mode1 = v.mode12
			elseif mode1 == "DFT" then
				Mode1 = v.mode13
			elseif mode1 == "MSD" then
				Mode1 = v.mode14
			end
			
			if mode2 == "DPS" then
				Mode2 = v.mode1
			elseif mode2 == "DMG" then
				Mode2 = v.mode2
			elseif mode2 == "HPS" then
				Mode2 = v.mode3
			elseif mode2 == "HLG" then
				Mode2 = v.mode4
			elseif mode2 == "OPS" then
				Mode2 = v.mode5
			elseif mode2 == "OHG" then
				Mode2 = v.mode6
			elseif mode2 == "OKL" then
				Mode2 = v.mode7
			elseif mode2 == "DTN" then
				Mode2 = v.mode8
			elseif mode2 == "HTN" then
				Mode2 = v.mode9
			elseif mode2 == "ASB" then
				Mode2 = v.mode10
			elseif mode2 == "AVD" then
				Mode2 = v.mode11
			elseif mode2 == "BLK" then
				Mode2 = v.mode12
			elseif mode2 == "DFT" then
				Mode2 = v.mode13
			elseif mode2 == "MSD" then
				Mode2 = v.mode14
			end
			
			total1 = total1 + Mode1
			total2 = total2 + Mode2
			nameText = nameText .. v.name .. "\n"
			mode1Text = mode1Text .. SuperMeter.Util.FormatNumber(Mode1) .. "\n"
			mode2Text = mode2Text .. SuperMeter.Util.FormatNumber(Mode2) .. "\n"
			
			if Mode1 > 0 or Mode2 > 0 then
				SuperMeter_value = true
			else
				SuperMeter_value = false
			end
			
			if export then
				local time = SuperMeter.Util.FormatTime(self:SetTime(true))
				if export1 then
					exportText1 = exportText1 .. v.name .. ": " .. SuperMeter.Util.FormatNumber(Mode1) .. " "
					self.copy:SetText(SuperMeter_side .. " " .. mode1 .. " " .. time .. " [ " .. exportText1 .. "]")
				end
				if export2 then
					exportText2 = exportText2 .. v.name .. ": " .. SuperMeter.Util.FormatNumber(Mode2) .. " "
					self.copy:SetText(SuperMeter_side .. " " .. mode2 .. " " .. time .. " [ " .. exportText2 .. "]")
				end
			end
			
			if mode1 == main then
				if total1 then
					total = total1
				end
			end
			if mode2 == main then
				if total2 then
					total = total2
				end
			end
		end
	end

	for i = 1, #sortTable do
		local player = Inspect.Unit.Detail("player")
		if sortTable[i].name == player.name then
			table.insert(colourTable, {r = 0, g = 0.6, b = 2.0, a = 0.68})
		elseif sortTable[i].calling == "cleric" then
			table.insert(colourTable, {r = 0.6, g = 0.8, b = 0.2, a = 0.68})
		elseif sortTable[i].calling == "mage" then
			table.insert(colourTable, {r = 0.6, g = 0.4, b = 0.8, a = 0.68})
		elseif sortTable[i].calling == "rogue" then
			table.insert(colourTable, {r = 0.6, g = -0.2, b = 0.0, a = 0.68})
		elseif sortTable[i].calling == "warrior" then
			table.insert(colourTable, {r = 0.8, g = 0.0, b = 0.0, a = 0.68})
		else
			table.insert(colourTable, {r = 0, g = 0.48, b = 0.88, a = 0.68})
		end
	end

	if sortTable[1] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[1][mode] and sortTable[1][mode] / total > 0 then
				self.unitbar1:SetText("")
				self.unitbar1:SetVisible(true)
				self.unitbar1:SetFontColor(0, 0, 0, 0)
				self.unitbar1:SetWidth(sortTable[1][mode] / total * width)
				self.unitbar1:SetBackgroundColor(colourTable[1].r, colourTable[1].g, colourTable[1].b, colourTable[1].a)
			else
				self.unitbar1:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar1:SetWidth(width)
			self.unitbar1:SetVisible(true)
			self.unitbar1:SetText(sortTable[1].name)
			self.unitbar1:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar1:SetFontColor(colourTable[1].r, colourTable[1].g, colourTable[1].b, colourTable[1].a)
		elseif SuperMeter_display == "None" then
			self.unitbar1:SetVisible(false)
		end
	else
		self.unitbar1:SetVisible(false)
	end

	if sortTable[2] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[2][mode] and sortTable[2][mode] / total > 0 then
				self.unitbar2:SetText("")
				self.unitbar2:SetVisible(true)
				self.unitbar2:SetFontColor(0, 0, 0, 0)
				self.unitbar2:SetWidth(sortTable[2][mode] / total * width)
				self.unitbar2:SetBackgroundColor(colourTable[2].r, colourTable[2].g, colourTable[2].b, colourTable[2].a)
			else
				self.unitbar2:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar2:SetWidth(width)
			self.unitbar2:SetVisible(true)
			self.unitbar2:SetText(sortTable[2].name)
			self.unitbar2:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar2:SetFontColor(colourTable[2].r, colourTable[2].g, colourTable[2].b, colourTable[2].a)
		elseif SuperMeter_display == "None" then
			self.unitbar2:SetVisible(false)
		end
	else
		self.unitbar2:SetVisible(false)
	end

	if sortTable[3] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[3][mode] and sortTable[3][mode] / total > 0 then
				self.unitbar3:SetText("")
				self.unitbar3:SetVisible(true)
				self.unitbar3:SetFontColor(0, 0, 0, 0)
				self.unitbar3:SetWidth(sortTable[3][mode] / total * width)
				self.unitbar3:SetBackgroundColor(colourTable[3].r, colourTable[3].g, colourTable[3].b, colourTable[3].a)
			else
				self.unitbar3:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar3:SetWidth(width)
			self.unitbar3:SetVisible(true)
			self.unitbar3:SetText(sortTable[3].name)
			self.unitbar3:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar3:SetFontColor(colourTable[3].r, colourTable[3].g, colourTable[3].b, colourTable[3].a)
		elseif SuperMeter_display == "None" then
			self.unitbar3:SetVisible(false)
		end
	else
		self.unitbar3:SetVisible(false)
	end

	if sortTable[4] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[4][mode] and sortTable[4][mode] / total > 0 then
				self.unitbar4:SetText("")
				self.unitbar4:SetVisible(true)
				self.unitbar4:SetFontColor(0, 0, 0, 0)
				self.unitbar4:SetWidth(sortTable[4][mode] / total * width)
				self.unitbar4:SetBackgroundColor(colourTable[4].r, colourTable[4].g, colourTable[4].b, colourTable[4].a)
			else
				self.unitbar4:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar4:SetWidth(width)
			self.unitbar4:SetVisible(true)
			self.unitbar4:SetText(sortTable[4].name)
			self.unitbar4:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar4:SetFontColor(colourTable[4].r, colourTable[4].g, colourTable[4].b, colourTable[4].a)
		elseif SuperMeter_display == "None" then
			self.unitbar4:SetVisible(false)
		end
	else
		self.unitbar4:SetVisible(false)
	end

	if sortTable[5] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[5][mode] and sortTable[5][mode] / total > 0 then
				self.unitbar5:SetText("")
				self.unitbar5:SetVisible(true)
				self.unitbar5:SetFontColor(0, 0, 0, 0)
				self.unitbar5:SetWidth(sortTable[5][mode] / total * width)
				self.unitbar5:SetBackgroundColor(colourTable[5].r, colourTable[5].g, colourTable[5].b, colourTable[5].a)
			else
				self.unitbar5:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar5:SetWidth(width)
			self.unitbar5:SetVisible(true)
			self.unitbar5:SetText(sortTable[5].name)
			self.unitbar5:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar5:SetFontColor(colourTable[5].r, colourTable[5].g, colourTable[5].b, colourTable[5].a)
		elseif SuperMeter_display == "None" then
			self.unitbar5:SetVisible(false)
		end
	else
		self.unitbar5:SetVisible(false)
	end

	if sortTable[6] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[6][mode] and sortTable[6][mode] / total > 0 then
				self.unitbar6:SetText("")
				self.unitbar6:SetVisible(true)
				self.unitbar6:SetFontColor(0, 0, 0, 0)
				self.unitbar6:SetWidth(sortTable[6][mode] / total * width)
				self.unitbar6:SetBackgroundColor(colourTable[6].r, colourTable[6].g, colourTable[6].b, colourTable[6].a)
			else
				self.unitbar6:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar6:SetWidth(width)
			self.unitbar6:SetVisible(true)
			self.unitbar6:SetText(sortTable[6].name)
			self.unitbar6:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar6:SetFontColor(colourTable[6].r, colourTable[6].g, colourTable[6].b, colourTable[6].a)
		elseif SuperMeter_display == "None" then
			self.unitbar6:SetVisible(false)
		end
	else
		self.unitbar6:SetVisible(false)
	end

	if sortTable[7] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[7][mode] and sortTable[7][mode] / total > 0 then
				self.unitbar7:SetText("")
				self.unitbar7:SetVisible(true)
				self.unitbar7:SetFontColor(0, 0, 0, 0)
				self.unitbar7:SetWidth(sortTable[7][mode] / total * width)
				self.unitbar7:SetBackgroundColor(colourTable[7].r, colourTable[7].g, colourTable[7].b, colourTable[7].a)
			else
				self.unitbar7:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar7:SetWidth(width)
			self.unitbar7:SetVisible(true)
			self.unitbar7:SetText(sortTable[7].name)
			self.unitbar7:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar7:SetFontColor(colourTable[7].r, colourTable[7].g, colourTable[7].b, colourTable[7].a)
		elseif SuperMeter_display == "None" then
			self.unitbar7:SetVisible(false)
		end
	else
		self.unitbar7:SetVisible(false)
	end

	if sortTable[8] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[8][mode] and sortTable[8][mode] / total > 0 then
				self.unitbar8:SetText("")
				self.unitbar8:SetVisible(true)
				self.unitbar8:SetFontColor(0, 0, 0, 0)
				self.unitbar8:SetWidth(sortTable[8][mode] / total * width)
				self.unitbar8:SetBackgroundColor(colourTable[8].r, colourTable[8].g, colourTable[8].b, colourTable[8].a)
			else
				self.unitbar8:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar8:SetWidth(width)
			self.unitbar8:SetVisible(true)
			self.unitbar8:SetText(sortTable[8].name)
			self.unitbar8:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar8:SetFontColor(colourTable[8].r, colourTable[8].g, colourTable[8].b, colourTable[8].a)
		elseif SuperMeter_display == "None" then
			self.unitbar8:SetVisible(false)
		end
	else
		self.unitbar8:SetVisible(false)
	end

	if sortTable[9] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[9][mode] and sortTable[9][mode] / total > 0 then
				self.unitbar9:SetText("")
				self.unitbar9:SetVisible(true)
				self.unitbar9:SetFontColor(0, 0, 0, 0)
				self.unitbar9:SetWidth(sortTable[9][mode] / total * width)
				self.unitbar9:SetBackgroundColor(colourTable[9].r, colourTable[9].g, colourTable[9].b, colourTable[9].a)
			else
				self.unitbar9:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar9:SetWidth(width)
			self.unitbar9:SetVisible(true)
			self.unitbar9:SetText(sortTable[9].name)
			self.unitbar9:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar9:SetFontColor(colourTable[9].r, colourTable[9].g, colourTable[9].b, colourTable[9].a)
		elseif SuperMeter_display == "None" then
			self.unitbar9:SetVisible(false)
		end
	else
		self.unitbar9:SetVisible(false)
	end

	if sortTable[10] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[10][mode] and sortTable[10][mode] / total > 0 then
				self.unitbar10:SetText("")
				self.unitbar10:SetVisible(true)
				self.unitbar10:SetFontColor(0, 0, 0, 0)
				self.unitbar10:SetWidth(sortTable[10][mode] / total * width)
				self.unitbar10:SetBackgroundColor(colourTable[10].r, colourTable[10].g, colourTable[10].b, colourTable[10].a)
			else
				self.unitbar10:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar10:SetWidth(width)
			self.unitbar10:SetVisible(true)
			self.unitbar10:SetText(sortTable[10].name)
			self.unitbar10:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar10:SetFontColor(colourTable[10].r, colourTable[10].g, colourTable[10].b, colourTable[10].a)
		elseif SuperMeter_display == "None" then
			self.unitbar10:SetVisible(false)
		end
	else
		self.unitbar10:SetVisible(false)
	end

	if sortTable[11] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[11][mode] and sortTable[11][mode] / total > 0 then
				self.unitbar11:SetText("")
				self.unitbar11:SetVisible(true)
				self.unitbar11:SetFontColor(0, 0, 0, 0)
				self.unitbar11:SetWidth(sortTable[11][mode] / total * width)
				self.unitbar11:SetBackgroundColor(colourTable[11].r, colourTable[11].g, colourTable[11].b, colourTable[11].a)
			else
				self.unitbar11:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar11:SetWidth(width)
			self.unitbar11:SetVisible(true)
			self.unitbar11:SetText(sortTable[11].name)
			self.unitbar11:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar11:SetFontColor(colourTable[11].r, colourTable[11].g, colourTable[11].b, colourTable[11].a)
		elseif SuperMeter_display == "None" then
			self.unitbar11:SetVisible(false)
		end
	else
		self.unitbar11:SetVisible(false)
	end

	if sortTable[12] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[12][mode] and sortTable[12][mode] / total > 0 then
				self.unitbar12:SetText("")
				self.unitbar12:SetVisible(true)
				self.unitbar12:SetFontColor(0, 0, 0, 0)
				self.unitbar12:SetWidth(sortTable[12][mode] / total * width)
				self.unitbar12:SetBackgroundColor(colourTable[12].r, colourTable[12].g, colourTable[12].b, colourTable[12].a)
			else
				self.unitbar12:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar12:SetWidth(width)
			self.unitbar12:SetVisible(true)
			self.unitbar12:SetText(sortTable[12].name)
			self.unitbar12:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar12:SetFontColor(colourTable[12].r, colourTable[12].g, colourTable[12].b, colourTable[12].a)
		elseif SuperMeter_display == "None" then
			self.unitbar12:SetVisible(false)
		end
	else
		self.unitbar12:SetVisible(false)
	end

	if sortTable[13] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[13][mode] and sortTable[13][mode] / total > 0 then
				self.unitbar13:SetText("")
				self.unitbar13:SetVisible(true)
				self.unitbar13:SetFontColor(0, 0, 0, 0)
				self.unitbar13:SetWidth(sortTable[13][mode] / total * width)
				self.unitbar13:SetBackgroundColor(colourTable[13].r, colourTable[13].g, colourTable[13].b, colourTable[13].a)
			else
				self.unitbar13:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar13:SetWidth(width)
			self.unitbar13:SetVisible(true)
			self.unitbar13:SetText(sortTable[13].name)
			self.unitbar13:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar13:SetFontColor(colourTable[13].r, colourTable[13].g, colourTable[13].b, colourTable[13].a)
		elseif SuperMeter_display == "None" then
			self.unitbar13:SetVisible(false)
		end
	else
		self.unitbar13:SetVisible(false)
	end

	if sortTable[14] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[14][mode] and sortTable[14][mode] / total > 0 then
				self.unitbar14:SetText("")
				self.unitbar14:SetVisible(true)
				self.unitbar14:SetFontColor(0, 0, 0, 0)
				self.unitbar14:SetWidth(sortTable[14][mode] / total * width)
				self.unitbar14:SetBackgroundColor(colourTable[14].r, colourTable[14].g, colourTable[14].b, colourTable[14].a)
			else
				self.unitbar14:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar14:SetWidth(width)
			self.unitbar14:SetVisible(true)
			self.unitbar14:SetText(sortTable[14].name)
			self.unitbar14:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar14:SetFontColor(colourTable[14].r, colourTable[14].g, colourTable[14].b, colourTable[14].a)
		elseif SuperMeter_display == "None" then
			self.unitbar14:SetVisible(false)
		end
	else
		self.unitbar14:SetVisible(false)
	end

	if sortTable[15] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[15][mode] and sortTable[15][mode] / total > 0 then
				self.unitbar15:SetText("")
				self.unitbar15:SetVisible(true)
				self.unitbar15:SetFontColor(0, 0, 0, 0)
				self.unitbar15:SetWidth(sortTable[15][mode] / total * width)
				self.unitbar15:SetBackgroundColor(colourTable[15].r, colourTable[15].g, colourTable[15].b, colourTable[15].a)
			else
				self.unitbar15:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar15:SetWidth(width)
			self.unitbar15:SetVisible(true)
			self.unitbar15:SetText(sortTable[15].name)
			self.unitbar15:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar15:SetFontColor(colourTable[15].r, colourTable[15].g, colourTable[15].b, colourTable[15].a)
		elseif SuperMeter_display == "None" then
			self.unitbar15:SetVisible(false)
		end
	else
		self.unitbar15:SetVisible(false)
	end

	if sortTable[16] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[16][mode] and sortTable[16][mode] / total > 0 then
				self.unitbar16:SetText("")
				self.unitbar16:SetVisible(true)
				self.unitbar16:SetFontColor(0, 0, 0, 0)
				self.unitbar16:SetWidth(sortTable[16][mode] / total * width)
				self.unitbar16:SetBackgroundColor(colourTable[16].r, colourTable[16].g, colourTable[16].b, colourTable[16].a)
			else
				self.unitbar16:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar16:SetWidth(width)
			self.unitbar16:SetVisible(true)
			self.unitbar16:SetText(sortTable[16].name)
			self.unitbar16:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar16:SetFontColor(colourTable[16].r, colourTable[16].g, colourTable[16].b, colourTable[16].a)
		elseif SuperMeter_display == "None" then
			self.unitbar16:SetVisible(false)
		end
	else
		self.unitbar16:SetVisible(false)
	end

	if sortTable[17] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[17][mode] and sortTable[17][mode] / total > 0 then
				self.unitbar17:SetText("")
				self.unitbar17:SetVisible(true)
				self.unitbar17:SetFontColor(0, 0, 0, 0)
				self.unitbar17:SetWidth(sortTable[17][mode] / total * width)
				self.unitbar17:SetBackgroundColor(colourTable[17].r, colourTable[17].g, colourTable[17].b, colourTable[17].a)
			else
				self.unitbar17:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar17:SetWidth(width)
			self.unitbar17:SetVisible(true)
			self.unitbar17:SetText(sortTable[17].name)
			self.unitbar17:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar17:SetFontColor(colourTable[17].r, colourTable[17].g, colourTable[17].b, colourTable[17].a)
		elseif SuperMeter_display == "None" then
			self.unitbar17:SetVisible(false)
		end
	else
		self.unitbar17:SetVisible(false)
	end

	if sortTable[18] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[18][mode] and sortTable[18][mode] / total > 0 then
				self.unitbar18:SetText("")
				self.unitbar18:SetVisible(true)
				self.unitbar18:SetFontColor(0, 0, 0, 0)
				self.unitbar18:SetWidth(sortTable[18][mode] / total * width)
				self.unitbar18:SetBackgroundColor(colourTable[18].r, colourTable[18].g, colourTable[18].b, colourTable[18].a)
			else
				self.unitbar18:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar18:SetWidth(width)
			self.unitbar18:SetVisible(true)
			self.unitbar18:SetText(sortTable[18].name)
			self.unitbar18:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar18:SetFontColor(colourTable[18].r, colourTable[18].g, colourTable[18].b, colourTable[18].a)
		elseif SuperMeter_display == "None" then
			self.unitbar18:SetVisible(false)
		end
	else
		self.unitbar18:SetVisible(false)
	end

	if sortTable[19] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[19][mode] and sortTable[19][mode] / total > 0 then
				self.unitbar19:SetText("")
				self.unitbar19:SetVisible(true)
				self.unitbar19:SetFontColor(0, 0, 0, 0)
				self.unitbar19:SetWidth(sortTable[19][mode] / total * width)
				self.unitbar19:SetBackgroundColor(colourTable[19].r, colourTable[19].g, colourTable[19].b, colourTable[19].a)
			else
				self.unitbar19:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar19:SetWidth(width)
			self.unitbar19:SetVisible(true)
			self.unitbar19:SetText(sortTable[19].name)
			self.unitbar19:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar19:SetFontColor(colourTable[19].r, colourTable[19].g, colourTable[19].b, colourTable[19].a)
		elseif SuperMeter_display == "None" then
			self.unitbar19:SetVisible(false)
		end
	else
		self.unitbar19:SetVisible(false)
	end

	if sortTable[20] then
		if SuperMeter_display == "Bars" then
			if not Mode1 or not Mode2 then return end
			if total and sortTable[20][mode] and sortTable[20][mode] / total > 0 then
				self.unitbar20:SetText("")
				self.unitbar20:SetVisible(true)
				self.unitbar20:SetFontColor(0, 0, 0, 0)
				self.unitbar20:SetWidth(sortTable[20][mode] / total * width)
				self.unitbar20:SetBackgroundColor(colourTable[20].r, colourTable[20].g, colourTable[20].b, colourTable[20].a)
			else
				self.unitbar20:SetVisible(false)
			end
		elseif SuperMeter_display == "Calling" then
			self.unitbar20:SetWidth(width)
			self.unitbar20:SetVisible(true)
			self.unitbar20:SetText(sortTable[20].name)
			self.unitbar20:SetBackgroundColor(0, 0, 0, 0)
			self.unitbar20:SetFontColor(colourTable[20].r, colourTable[20].g, colourTable[20].b, colourTable[20].a)
		elseif SuperMeter_display == "None" then
			self.unitbar20:SetVisible(false)
		end
	else
		self.unitbar20:SetVisible(false)
	end

	sortTable = {}
	colourTable = {}
	self:CombatTotal(total1, total2)
	self:CombatText(nameText, mode1Text, mode2Text)
end

function Interface:GetUnit()
	local encounter = encounter()
	local mouse = Inspect.Mouse()
	local top = self.combattext1:GetTop()
	local interval = mouse.y - top
	local sortTable = {}
	local unit = nil
	local max = 0

	if SuperMeter_side == "Allies" then
		sortTable = encounter.allies
	else
		sortTable = encounter.enemies
	end

	if #sortTable <= 20 then
		max = self.combattext1:GetHeight() / #sortTable
	else
		max = self.combattext1:GetHeight() / 20
	end

	for k,v in pairs (sortTable) do
		if sortTable[1] then
			if interval <= max then
				unit = sortTable[1]
			end
			for i = 1, interval / max do
				unit = sortTable[i+1]
			end
		end
	end

	for k,v in pairs (encounter.units) do
		if unit and unit.name == encounter.units[k].name then
			return encounter.units[k]
		end
	end

	sortTable = {}
end

function Interface:Update()
	self:DataSort()
	self:FrameSort()
end

function Interface:TipColours(mouseIn)
	if mouseIn then
		if SuperMeter_side == "Allies" then
			self.tipbg:SetBackgroundColor(0, 0.4, 0, 2)
		end
		if SuperMeter_side == "Enemies" then
			self.tipbg:SetBackgroundColor(0.4, 0, 0, 2)
		end
	else
		self.tipbg:SetBackgroundColor(0, 0.4, 0.8, 2)
	end
end

function Interface:InfotipShow(text)
	self.infotiptext:SetText(text)
	self.infotip:SetHeight(self.infotiptext:GetHeight() + 10)
	self.infotip:SetWidth(self.infotiptext:GetWidth() + 16)
	self.tipbg:SetWidth(self.infotip:GetWidth() + 2)

	if self.datatip:GetVisible() then
		self.tipbg:SetHeight(self.infotip:GetHeight() + self.datatip:GetHeight() + 2.8)
	else
		self.tipbg:SetHeight(self.infotip:GetHeight() + 1.8)
	end

	if (self.infotiptext:GetWidth() + 16) < (SuperMeter_width - 2) then
		self.infotip:SetWidth(SuperMeter_width - 2)
		self.tipbg:SetWidth(self.infotip:GetWidth() + 2)
	end

	self.tipbg:SetVisible(true)
	self.infotip:SetVisible(true)
end

function Interface:InfotipHide()
	self.infotiptext:SetText("")
	self.tipbg:SetVisible(false)
	self.infotip:SetVisible(false)
end

function Interface:DatatipShow(text)
	self.datatiptext:SetText(text)
	self.datatip:SetWidth(self.infotip:GetWidth())
	self.datatip:SetHeight(self.datatiptext:GetHeight() + 10)
	self.datatip:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -0.48, -self.infotip:GetHeight() -120.8)

	if self.infotip:GetVisible() then
		self.tipbg:SetHeight(self.infotip:GetHeight() + self.datatip:GetHeight() + 2.8)
	else
		self.tipbg:SetHeight(self.infotip:GetHeight() + 1.8)
	end

	if self.datatiptext:GetWidth() > self.infotiptext:GetWidth() then
		self.infotip:SetWidth(self.datatiptext:GetWidth() + 22)
		self.tipbg:SetWidth(self.infotip:GetWidth() + 2)
		self.datatip:SetWidth(self.infotip:GetWidth())
	end

	self.tipbg:SetVisible(true)
	self.datatip:SetVisible(true)
end

function Interface:DatatipHide()
	self.datatiptext:SetText("")
	self.tipbg:SetVisible(false)
	self.datatip:SetVisible(false)
end

Encounter = {}
function Encounter:new()
	local o = {
		combatTime = 0,
		startCombat = 0,
		units = {},
		allies = {},
		enemies = {},
		deathlog = {},
	}

	setmetatable(o, self)
	self.__index = self
	return o
end

function Encounter:StartCombat(time)
	self.startCombat = time
end

function Encounter:EndCombat(time)
	self.combatTime = time - self.startCombat + self.combatTime
end

function Encounter:GetUnit(id)
	local detail = Inspect.Unit.Detail(id)
	local owner = Inspect.Unit.Detail(id .. ".owner")

	for k,v in pairs (self.units) do
		if detail and not owner then
			if detail.name == self.units[k].name then
				return self.units[k]
			end
		end
	end

	if detail and not owner then
		if detail.name == "" then return nil end
		if not self.units[detail.id] then
			local unit = Unit:new(detail)
			self.units[detail.id] = unit
		end
	end

	if owner and owner.id then
		if owner.name == "" then return nil end
		if not self.units[owner.id] then
			local unit = Unit:new(owner)
			self.units[owner.id] = unit
		end
	end

	if owner then
		return self.units[owner.id]
	end
	if detail then
		return self.units[detail.id]
	end
end

Unit = {}
function Unit:new(detail)
	local o = {
		calling = detail.calling,
		level = detail.level,
		name = detail.name,
		relation = detail.relation,
		player = detail.player,
		damage = 0,
		damageAbsorbed = 0,
		damageAbsorbIn = 0,
		damageAvoided = 0,
		damageAvoidIn = 0,
		damageBlocked = 0,
		damageBlockIn = 0,
		damageCritical = 0,
		damageDeflected = 0,
		damageDeflectIn = 0,
		damageIn = 0,
		damageMissed = 0,
		damageMitigable = 0,
		damageNonCritical = 0,
		damageOut = 0,
		damageTaken = 0,
		damageTakenCritical = 0,
		damageTakenNonCritical = 0,
		healing = 0,
		healingCritical = 0,
		healingIn = 0,
		healingNonCritical = 0,
		healingOut = 0,
		healingTaken = 0,
		healingTakenCritical = 0,
		healingTakenNonCritical = 0,
		overHealing = 0,
		overHealingCritical = 0,
		overhealingNonCritical = 0,
		overHealingOut = 0,
		overKill = 0,
		overKillCritical = 0,
		overKillOut = 0,
		overKillNonCritical = 0,
		abilities = {},
		combatlog = {},
	}

	setmetatable(o, self)
	self.__index = self
	return o
end

function Unit:AddDamage(ability, damage)
	local ability = self:GetAbility(ability)
	self.damageOut = self.damageOut + 1
	self.damage = self.damage + damage
	ability.damage = ability.damage + damage
end

function Unit:AddDamageAbsorbed(ability, damageAbsorbed)
	local ability = self:GetAbility(ability)
	self.damageAbsorbIn = self.damageAbsorbIn + 1
	self.damageAbsorbed = self.damageAbsorbed - damageAbsorbed
	ability.damageAbsorbed = ability.damageAbsorbed - damageAbsorbed
end

function Unit:AddDamageAvoided(ability, damageAvoided)
	local ability = self:GetAbility(ability)
	self.damageAvoided = self.damageAvoided + 1
	ability.damageAvoided = ability.damageAvoided + 1
end

function Unit:AddDamageAvoidable()
	self.damageAvoidIn = self.damageAvoidIn + 1
end

function Unit:AddDamageBlocked(ability, damageBlocked)
	local ability = self:GetAbility(ability)
	self.damageBlockIn = self.damageBlockIn + 1
	self.damageBlocked = self.damageBlocked + damageBlocked
	ability.damageBlocked = ability.damageBlocked + damageBlocked
end

function Unit:AddDamageCritical()
	self.damageCritical = self.damageCritical + 1
end

function Unit:AddDamageNonCritical()
	self.damageNonCritical = self.damageNonCritical + 1
end

function Unit:AddDamageDeflected(ability, damageDeflected)
	local ability = self:GetAbility(ability)
	self.damageDeflectIn = self.damageDeflectIn + 1
	self.damageDeflected = self.damageDeflected + damageDeflected
	ability.damageDeflected = ability.damageDeflected + damageDeflected
end

function Unit:AddDamageMissed(ability, damageMissed)
	local ability = self:GetAbility(ability)
	self.damageMissed = self.damageMissed + 1
	ability.damageMissed = ability.damageMissed + 1
end

function Unit:AddDamageMitigable()
	self.damageMitigable = self.damageMitigable + 1
end

function Unit:AddDamageTaken(ability, damageTaken)
	local ability = self:GetAbility(ability)
	self.damageIn = self.damageIn + 1
	self.damageTaken = self.damageTaken + damageTaken
	ability.damageTaken = ability.damageTaken + damageTaken
end

function Unit:AddDamageTakenCritical()
	self.damageTakenCritical = self.damageTakenCritical + 1
end

function Unit:AddDamageTakenNonCritical()
	self.damageTakenNonCritical = self.damageTakenNonCritical + 1
end

function Unit:AddHealing(ability, healing)
	local ability = self:GetAbility(ability)
	self.healingOut = self.healingOut + 1
	self.healing = self.healing + healing
	ability.healing = ability.healing + healing
end

function Unit:AddHealingCritical()
	self.healingCritical = self.healingCritical + 1
end

function Unit:AddHealingNonCritical()
	self.healingNonCritical = self.healingNonCritical + 1
end

function Unit:AddHealingTaken(ability, healingTaken)
	local ability = self:GetAbility(ability)
	self.healingIn = self.healingIn + 1
	self.healingTaken = self.healingTaken + healingTaken
	ability.healingTaken = ability.healingTaken + healingTaken
end

function Unit:AddHealingTakenCritical()
	self.healingTakenCritical = self.healingTakenCritical + 1
end

function Unit:AddHealingTakenNonCritical()
	self.healingTakenNonCritical = self.healingTakenNonCritical + 1
end

function Unit:AddOverHealing(ability, overHealing)
	local ability = self:GetAbility(ability)
	self.overHealingOut = self.overHealingOut + 1
	self.overHealing = self.overHealing + overHealing
	ability.overHealing = ability.overHealing + overHealing
end

function Unit:AddOverHealingCritical()
	self.overHealingCritical = self.overHealingCritical + 1
end

function Unit:AddOverHealingNonCritical()
	self.overhealingNonCritical = self.overhealingNonCritical + 1
end

function Unit:AddOverKill(ability, overKill)
	local ability = self:GetAbility(ability)
	self.overKillOut = self.overKillOut + 1
	self.overKill = self.overKill + overKill
	ability.overKill = ability.overKill + overKill
end

function Unit:AddOverKillCritical()
	self.overKillCritical = self.overKillCritical + 1
end

function Unit:AddOverKillNonCritical()
	self.overKillNonCritical = self.overKillNonCritical + 1
end

function Unit:GetAbility(ability)
	if not self.abilities[ability] then
		self.abilities[ability] = {
			damage = 0,
			damageAbsorbed = 0,
			damageAvoided = 0,
			damageBlocked = 0,
			damageDeflected = 0,
			damageMissed = 0,
			damageTaken = 0,
			healing = 0,
			healingTaken = 0,
			overHealing = 0,
			overKill = 0,
		}
	end
	return self.abilities[ability]
end

function SuperMeter:ResetState()
	SuperMeter_value = false
	SuperMeter_inCombat = false
	SuperMeter_bossActive = false
	SuperMeter_forceStart = false
	SuperMeter.state.encounters = {}
	SuperMeter.state.encounterIndex = 0
	SuperMeter.state.encounterOffset = 0
	SuperMeter.state.lastUpdate = -1
	SuperMeter.UI.Interface:ResetText()
	SuperMeter.UI.Interface:ChangeEncounter()
end

function SuperMeter.Init(addon)
	if addon == "SuperMeter" then
		SuperMeter.UI.Interface = Interface:new()
		SuperMeter.UI.Interface:Relation()
		SuperMeter.UI.Interface:Display()
		SuperMeter.UI.Interface:SetSize()
	end
end

function SuperMeter.Util.FormatTime(time)
	if time then
		local hour = math.floor(time / 60 / 60)
		local min = math.floor(time / 60) % 60
		local sec = time % 60
		
		if hour > 0 then
			return string.format("%02d:%02d:%02d", hour, min, sec)
		else
			return string.format("%02d:%02d", min, sec)
		end
	end
end

function SuperMeter.Util.FormatNumber(number)
	if number then
		if number < 10000 then
			return string.format("%d", number)
		elseif number < 100000 then
			return string.format("%4.1fk", number / 1000)
		elseif number < 1000000 then
			return string.format("%dk", number / 1000)
		elseif number < 10000000 then
			return string.format("%4.2fm", number / 1000000)
		elseif number < 100000000 then
			return string.format("%4.1fm", number / 1000000)
		else
			return string.format("%dm", number / 1000000)
		end
	end
end

function SuperMeter.SlashHandler(args)
	local cmd = args

	if cmd == "disable" then
		if SuperMeter_enabled then
			SuperMeter_enabled = false
		else
			SuperMeter_enabled = true
		end
		SuperMeter:ResetState()
		SuperMeter.UI.Interface:Toggle()
		return
	elseif cmd == "help" then 
		SuperMeter:GetHelp()
		return
	elseif cmd == "log disable" then
		if SuperMeter_logEnabled then
			SuperMeter_logEnabled = false
		else
			SuperMeter_logEnabled = true
		end
		SuperMeter.UI.Interface:DeathLogHide()
		return
	elseif cmd == "font scale" then
		if SuperMeter_fontSize == 14 then
			SuperMeter_fontSize = 13
			SuperMeter_width = 256
		else
			SuperMeter_fontSize = 14
			SuperMeter_width = 268
		end
		print("Please type /reloadui for this to take effect")
		return
	elseif cmd == "window alpha" then
		if SuperMeter_alpha == 0.8 then
			SuperMeter_alpha = 0.688
		else
			SuperMeter_alpha = 0.8
		end
		print("Please type /reloadui for this to take effect")
		return
	elseif cmd == "window scale" then
		SuperMeter.UI.Interface:SetSize(true)
		return
	elseif cmd == "toggle" then
		SuperMeter.UI.Interface:Toggle()
		return
	elseif cmd == "reset" then
		SuperMeter_alpha = 0.8
		SuperMeter_display = "Calling"
		SuperMeter_bossActive = false
		SuperMeter_enabled = true
		SuperMeter_fontSize = 14
		SuperMeter_growUp = false
		SuperMeter_logEnabled = true
		SuperMeter_logX = 626
		SuperMeter_logY = 760
		SuperMeter_maxSlots = 5
		SuperMeter_mode = "DPS"
		SuperMeter_mode1 = "DPS"
		SuperMeter_mode2 = "HPS"
		SuperMeter_side = "Allies"
		SuperMeter_width = 268
		SuperMeter_x = 820
		SuperMeter_y = 600
		SuperMeter:ResetState()
		SuperMeter.UI.Interface:SetSize()
		return
	end
	print("Super Meter Commands:")
	print("/sm disable - To disable/enable Super Meter")
	print("/sm help - To open the Super Meter help file")
	print("/sm log disable - To disable/enable the Super Meter player death log")
	print("/sm toggle - Toogles the Super Meter frame and reduces CPU usage")
	print("/sm reset - Resets Super Meter to its default settings")
	print("/sm font scale - Changes the size of the Super Meter font size")
	print("/sm window alpha  - Changes the alpha of the Super Meter window")
	print("/sm window scale - Changes the size of the Super Meter window size")
end

function SuperMeter:GetHelp()
	print("Change modes by right clicking a mode.")
	print("Left click the mode labels to change sorting.")
	print("To export click on the total frame in that column.")
	print("Switch between allies and enemies by left clicking the relation frame.")
	print("Type '/sm' to view all Super Meter commands.")
end

function encounter()
	if #SuperMeter.state.encounters >= 1 then
		return SuperMeter.state.encounters[SuperMeter.state.encounterIndex - SuperMeter.state.encounterOffset]
	else
		return Encounter:new()
	end
end

function SuperMeter.Update()
	if SuperMeter_enabled then
		local now = Inspect.Time.Frame()
		
		if SuperMeter_inCombat then
			if (now - SuperMeter.state.lastUpdate) > 0.88 then
				SuperMeter.UI.Interface:Update()
				SuperMeter.state.lastUpdate = now
			end
			SuperMeter.UI.Interface:SetTime(false)
		end
	end
end

function SuperMeter:GetLog(unit)
	if SuperMeter_logEnabled then
		if SuperMeter_logShowing then
			local encounter = encounter()
			local target = Inspect.Unit.Detail("player" .. ".target")
			local title = "Target A Player And Click Here For The Player Combat Log"
			local logData = ""
			
			if unit then
				for k,v in pairs (unit.combatlog) do
					logData = logData .. v .. "\n"
					title = unit.name .. " 's Combat Log"
				end
			end
			
			if not unit and target and target.player then
				if encounter.units[target.id] then
					for k,v in pairs (encounter.units[target.id].combatlog) do
						logData = logData .. v .. "\n"
						title = target.name .. " 's Combat Log"
					end
				end
			else
				if not unit then
					for k,v in pairs (encounter.deathlog) do
						logData = logData .. v .. "\n"
					end
				end
			end
			
			SuperMeter.UI.Interface:DeathLog(logData)
			SuperMeter.UI.Interface:DeathLogUnit(title)
		end
	end
end

function SuperMeter:AbilityData(caster, casterName, target, targetName, ability, type, damage, crit, absorbed, blocked, overkill, dodge, heal, overheal, miss, parry, resist)
	if SuperMeter_inCombat then
		if SuperMeter_enabled then
			local owner = Inspect.Unit.Detail(caster .. ".owner")
			
			abilityName = ability
			
			if abilityName == "attack" then
				abilityName = "Attack"
			end
			
			if damage then
				damageType = type
				if damageType == nil then
					damageType = "Physical"
				elseif damageType == "air" then
					damageType = "Air"
				elseif damageType == "death" then
					damageType = "Death"
				elseif damageType == "earth" then
					damageType = "Earth"
				elseif damageType == "fire" then
					damageType = "Fire"
				elseif damageType == "life" then
					damageType = "Life"
				elseif damageType == "water" then
					damageType = "Water"
				end
				if owner then
					abilityName = abilityName .. " ( Pet ) ( " .. damageType .. " )"
				else
					abilityName = abilityName .. " ( " .. damageType .. " )"
				end
			else
				damageType = ""
				if owner then
					abilityName = abilityName .. " ( Pet ) "
				else
					abilityName = abilityName
				end
			end
			
			if BossActive[casterName] then
				if not SuperMeter_bossActive then
					SuperMeter_split = true
					SuperMeter_bossActive = true
					SuperMeter.Event.Combat()
				end
			end
			
			if BossActive[targetName] then
				if not SuperMeter_bossActive then
					SuperMeter_split = true
					SuperMeter_bossActive = true
					SuperMeter.Event.Combat()
				end
			end
		end
	end
end

function SuperMeter:DeathLog(caster, casterName, target, targetName, ability, damage, crit, damageAbsorbed, damageBlocked, damageDeflected, damageModified, overkill, heal, overheal)
	if SuperMeter_logEnabled then
		if SuperMeter_inCombat then
			if SuperMeter_enabled then
				local encounter = encounter()
				local targetID = ""
				
				if target then
					targetID = Inspect.Unit.Detail(target)
				end
				
				if targetID and targetID.player then
					if damage or heal or overkill then
						if encounter.units[targetID.id] then
							if targetID.relation == "hostile" then return end
							
							local data = {
								Absorbed = "",
								Ability = "Unknown",
								Blocked = "",
								Caster = "Unknown's ",
								Critical = "",
								Damage = "Unknown",
								DamageType = "",
								Deflected = "",
								Heal = "Unknown",
								OverHeal = "",
								Modified = "",
								OverKill = "",
								Target = "Unknown's ",
								Time = "[" .. SuperMeter.Util.FormatTime(SuperMeter.UI.Interface:SetTime(true)) .. "] ",
							}
							
							local deathData = nil
							local damageData = nil
							local healingData = nil
							
							if ability == "attack" then
								ability = "Attack"
							end
							
							if ability then
								data.Ability = ability
							end
							
							if casterName then
								data.Caster = casterName .. "'s "
							end
							
							if crit then
								data.Critical = " Critically"
							end
							
							if damage then
								data.Damage = damage .. " "
							end
							
							if damageAbsorbed then
								data.Absorbed = " (" .. damageAbsorbed .. " Absorbed)"
							end
							
							if damageBlocked then
								data.Blocked = " (" .. damageBlocked .. " Blocked)"
							end
							
							if damageDeflected then
								data.Deflected = " (" .. damageDeflected .. " Deflected)"
							end
							
							if damageModified then
								data.Modified = " (" .. damageModified.. " Modified)"
							end
							
							if damageType then
								data.DamageType = damageType .. " Damage"
							end
							
							if heal then
								data.Heal = heal
							end
							
							if overheal then
								data.OverHeal = " (" .. overheal .. " Overheal)"
							end
							
							if overkill then
								data.OverKill = " (" .. overkill .. " Overkill)"
							end
							
							if targetName then
								data.Target = targetName .. " For "
							end
							
							if damage then
								damageData = "[Damage] " .. data.Time .. data.Caster .. data.Ability .. data.Critical .. " Hits " .. data.Target .. data.Damage .. data.DamageType .. data.Modified .. data.Absorbed .. data.Blocked .. data.Deflected .. data.OverKill .. "."
								table.insert(encounter.units[targetID.id].combatlog, damageData)
								damageData = nil
							end
							
							if heal then
								healingData = "[Healing] " .. data.Time .. data.Caster .. data.Ability .. data.Critical .. " Heals " .. data.Target .. data.Heal .. data.OverHeal .. "."
								table.insert(encounter.units[targetID.id].combatlog, healingData)
								healingData = nil
							end
							
							if overkill then
								deathData = "[Death] " .. data.Time .. data.Caster .. data.Ability .. data.Critical .. " Hits " .. data.Target .. data.Damage .. data.DamageType .. data.Modified .. data.Absorbed .. data.Blocked .. data.Deflected .. data.OverKill .. "."
								table.insert(encounter.deathlog, deathData)
								if targetID.id == Inspect.Unit.Lookup("player") then
									print(deathData)
								end
								deathData = nil
							end
							
							if #encounter.units[targetID.id].combatlog >= 40 then
								table.remove(encounter.units[targetID.id].combatlog, 1)
							end
							
							data = {}
						end
					end
				end
			end
		end
	end
end

function SuperMeter.Event.Combat(params)
	if SuperMeter_enabled then
		local now = Inspect.Time.Frame()
		local encounter = Encounter:new()
		local player = Inspect.Unit.Detail("player")
		local inCombat = false
		local groupCombat = false
		
		if not params then params = {} end
		
		for k,v in pairs (params) do
			encounter:GetUnit(k)
		end
		
		if player and player.zone then
			local unitZone = Inspect.Zone.Detail(player.zone)
			if unitZone.type == "instance" then
				for i = 1, 20 do
					local group = string.format("group%02d", i)
					local groupUnit = Inspect.Unit.Detail(group)
					if groupUnit and groupUnit.combat and groupUnit.zone then
						local unitZone = Inspect.Zone.Detail(groupUnit.zone)
						if unitZone.type == "instance" then 
							groupCombat = true
						end
					end
				end
			end
		end
		
		if SuperMeter_split then
			if SuperMeter_inCombat then
				SuperMeter_split = false
				SuperMeter_inCombat = false
				SuperMeter_forceStart = false
				SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:EndCombat(now)
			end
		end
		
		if groupCombat then inCombat = true end
		if not groupCombat and player then inCombat = player.combat end
		
		if inCombat or SuperMeter_forceStart then
			if not SuperMeter_inCombat then
				SuperMeter_inCombat = true
				SuperMeter.state.lastUpdate = -1
				SuperMeter.state.encounterIndex = SuperMeter.state.encounterIndex + 1
				
				if SuperMeter.state.encounterOffset > 0 then
					SuperMeter.state.encounterOffset = SuperMeter.state.encounterOffset  + 1
				end
				
				while SuperMeter.state.encounterIndex > 88 do
					table.remove(SuperMeter.state.encounters, 1)
					SuperMeter.state.encounterIndex = SuperMeter.state.encounterIndex - 1
					if SuperMeter.state.encounterOffset > 0 then
						SuperMeter.state.encounterOffset = SuperMeter.state.encounterOffset  - 1
					end
				end
				
				SuperMeter.state.encounters[SuperMeter.state.encounterIndex] = encounter
				encounter:StartCombat(now)
				SuperMeter.UI.Interface:ChangeEncounter()
			end
		elseif not inCombat and not SuperMeter_forceStart then
			if SuperMeter_inCombat then
				SuperMeter_inCombat = false
				SuperMeter_bossActive = false
				
				SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:EndCombat(now)
				SuperMeter.UI.Interface:ChangeEncounter()
			end
		end
	end
end

function SuperMeter.Event.Damage(params)
	if SuperMeter_enabled then
		if SuperMeter_inCombat then
			SuperMeter:AbilityData(params.caster, params.casterName, params.target, params.targetName, params.abilityName, params.type, true)
			SuperMeter:DeathLog(params.caster, params.casterName, params.target, params.targetName, params.abilityName, params.damage, params.crit, params.damageAbsorbed, params.damageBlocked, params.damageDeflected, params.damageModified, params.overkill)
			
			local Caster = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.caster)
			local Target = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.target)
			
			if Mitigable[params.abilityName] then
				if Target then
					Target:AddDamageMitigable()
				end
			end
			
			if not UnAvoidable[params.abilityName] then
				if Target then
					Target:AddDamageAvoidable()
				end
			end
			
			if not UnMitigable[params.abilityName] then
				if params.type == nil then
					if Target then
						Target:AddDamageMitigable()
					end
				end
			end
			
			if DamageCritical[params.abilityName] then
				if params.damage then
					if Caster then
						Caster:AddDamageNonCritical()
					end
					if Target then
						Target:AddDamageTakenNonCritical()
					end
				end
				if params.overkill then
					if Caster then
						Caster:AddOverKillNonCritical()
					end
				end
			end
			
			if params.crit then
				if params.damage then
					if not Damage[params.abilityName] then
						if Caster then
							Caster:AddDamageCritical()
						end
						if Target then
							Target:AddDamageTakenCritical()
						end
					end
				end
				if params.overkill then
					if not OverKill[params.abilityName] then
						if Caster then
							Caster:AddOverKillCritical()
						end
					end
				end
			end
			
			if params.damage then
				if not Damage[params.abilityName] then
					if Caster then
						Caster:AddDamage(abilityName, params.damage)
					end
				end
				if not DamageTaken[params.abilityName] then
					if Target then
						Target:AddDamageTaken(abilityName, params.damage)
					end
				end
			end
			
			if params.damageAbsorbed then
				if not DamageAbsorbed[params.abilityName] then
					if Target then
						Target:AddDamageAbsorbed(abilityName, params.damageAbsorbed)
					end
				end
			end
			
			if params.damageBlocked then
				if not DamageBlocked[params.abilityName] then
					if Target then
						Target:AddDamageBlocked(abilityName, params.damageBlocked)
					end
				end
			end
			
			if params.damageDeflected then
				if not DamageDeflected[params.abilityName] then
					if Target then
						Target:AddDamageDeflected(abilityName, params.damageDeflected)
					end
				end
			end
			
			if params.overkill then
				if not OverKill[params.abilityName] then
					if Caster then
						Caster:AddOverKill(abilityName, params.overkill)
					end
				end
			end
		end
	end
end

function SuperMeter.Event.Dodge(params)
	if SuperMeter_enabled then
		if SuperMeter_inCombat then
			if not DamageAvoided[params.abilityName] then
				SuperMeter:AbilityData(params.caster, params.casterName, params.target, params.targetName, params.abilityName)
				
				local Caster = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.caster)
				local Target = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.target)
				
				if Target then
					Target:AddDamageAvoided(abilityName)
				end
			end
		end
	end
end

function SuperMeter.Event.Heal(params)
	if SuperMeter_enabled then
		if SuperMeter_inCombat then
			SuperMeter:AbilityData(params.caster, params.casterName, params.target, params.targetName, params.abilityName)
			SuperMeter:DeathLog(params.caster, params.casterName, params.target, params.targetName, params.abilityName, nil, params.crit, nil, nil, nil, nil, nil, params.heal, params.overheal)
			
			local Caster = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.caster)
			local Target = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.target)
			
			if HealingCritical[params.abilityName] then
				if params.heal then
					if Caster then
						Caster:AddHealingNonCritical()
					end
					if Target then
						Target:AddHealingTakenNonCritical()
					end
				end
				if params.overheal then
					if Caster then
						Caster:AddOverHealingNonCritical()
					end
				end
			end
			
			if params.crit then
				if params.heal then
					if not Healing[params.abilityName] then
						if Caster then
							Caster:AddHealingCritical()
						end
						if Target then
							Target:AddHealingTakenCritical()
						end
					end
				end
				if params.overheal then
					if not OverHealing[params.abilityName] then
						if Caster then
							Caster:AddOverHealingCritical()
						end
					end
				end
			end
			
			if params.heal then
				if not Healing[params.abilityName] then
					if Caster then
						Caster:AddHealing(abilityName, params.heal)
					end
				end
				if not HealingTaken[params.abilityName] then
					if Target then
						Target:AddHealingTaken(abilityName, params.heal)
					end
				end
			end
			
			if params.overheal then
				if not OverHealing[params.abilityName] then
					if Caster then
						Caster:AddOverHealing(abilityName, params.overheal)
					end
				end
			end
		end
	end
end

function SuperMeter.Event.Miss(params)
	if SuperMeter_enabled then
		if SuperMeter_inCombat then
			if not DamageMissed[params.abilityName] then
				SuperMeter:AbilityData(params.caster, params.casterName, params.target, params.targetName, params.abilityName)
				
				local Caster = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.caster)
				local Target = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.target)
				
				if Target then
					Target:AddDamageAvoided(abilityName)
				end
			end
		end
	end
end

function SuperMeter.Event.Parry(params)
	if SuperMeter_enabled then
		if SuperMeter_inCombat then
			if not DamageAvoided[params.abilityName] then
				SuperMeter:AbilityData(params.caster, params.casterName, params.target, params.targetName, params.abilityName)
				
				local Caster = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.caster)
				local Target = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.target)
				
				if Target then
					Target:AddDamageAvoided(abilityName)
				end
			end
		end
	end
end

function SuperMeter.Event.Resist(params)
	if SuperMeter_enabled then
		if SuperMeter_inCombat then
			if not DamageAvoided[params.abilityName] then
				SuperMeter:AbilityData(params.caster, params.casterName, params.target, params.targetName, params.abilityName)
				
				local Caster = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.caster)
				local Target = SuperMeter.state.encounters[SuperMeter.state.encounterIndex]:GetUnit(params.target)
				
				if Target then
					Target:AddDamageAvoided(abilityName)
				end
			end
		end
	end
end

table.insert(Command.Slash.Register("SM"), {SuperMeter.SlashHandler, "SuperMeter", "Slash Command"})
table.insert(Event.Addon.Load.End, {SuperMeter.Init, "SuperMeter", "Initital Setup"})
table.insert(Event.System.Update.Begin, {SuperMeter.Update, "SuperMeter", "Update UI"})
table.insert(Event.System.Update.End, {SuperMeter.Update, "SuperMeter", "Update UI"})
table.insert(Event.Unit.Detail.Combat, {SuperMeter.Event.Combat, "SuperMeter", "Handle Combat"})
table.insert(Event.Combat.Damage, {SuperMeter.Event.Damage, "SuperMeter", "Handle Damage"})
table.insert(Event.Combat.Dodge, {SuperMeter.Event.Dodge, "SuperMeter", "Handle Dodges"})
table.insert(Event.Combat.Heal, {SuperMeter.Event.Heal, "SuperMeter", "Handle Heals"})
table.insert(Event.Combat.Miss, {SuperMeter.Event.Miss, "SuperMeter", "Handle Misses"})
table.insert(Event.Combat.Parry, {SuperMeter.Event.Parry, "SuperMeter", "Handle Parries"})
table.insert(Event.Combat.Resist, {SuperMeter.Event.Resist, "SuperMeter", "Handle Resists"})