nkLog = { 
	log = {},
	levelFatal = 1,
	levelError = 2,
	levelWarning = 3,
	levelInfo = 4,
}

local privateVars = ...

privateVars = {}

function nkLog.nkDebug ()

	local addonList = Inspect.Addon.List()
	if addonList.nkDebug == nil then return false else return true end

end

function nkLog.log:new (addon, id)

	local this = {}
	this.addon = addon
	this.id = id
	this.registered = false
	this.messages = {}
	this.performance = {}
		
	setmetatable(this, self)
	self.__index = self
	return this

end

function nkLog.log:logMessage (message, level)
	
	if nkLog.nkDebug () == false then return end
	
	if self.registered == false then
		table.insert (nkDebugGlobalVars.logs, self)
		self.registered = true
	end

	local colors = {'FF0000', 'FF6A00', 'FFD800', 'FFFFFF'}

	local now = os.date()
	local timeText = string.sub(now, string.find(now, ' ')+1)
	
	table.insert (self.messages, 1, {{ value = timeText, color = colors[level]}, { value = message, color = colors[level]} })
	
end

function nkLog.log:logPerformance (identifier)

	if nkLog.nkDebug () == false then return end
	
	if self.registered == false then
		table.insert (nkDebugGlobalVars.logs, self)
		self.registered = true
	end

	if self.performance[identifier] == nil then
		self.performance[identifier] = Inspect.Time.Real()	
	else
		local message = string.format ('%s took %.4f seconds', identifier, (Inspect.Time.Real() - self.performance[identifier] ))
		self:logMessage (message, 4)
		self.performance[identifier] = nil
	end
	
end
