local nkGenie, privateVars = ...

function nkGenie.ExtProgressBar:new(name, parent, settings)

	local this = {}
	this.name = name
	this.parent = parent
	this.props = {}
	
	local element = UI.CreateFrame("nkExtFrame", name, parent, { anchors = settings.anchors, width = settings.width, height = settings.height, color = {body = settings.borderColor } })
	element.fill = UI.CreateFrame("nkExtFrame", name, element:getElement(), { layer = 1, anchors = {{ from = "CENTERLEFT", object = element:getElement(), to = "CENTERLEFT", x = 2, y = 0}}, width = 1, height = settings.height - 4, color = { body = settings.fillColor }})
	element.label = UI.CreateFrame("nkExtText", name, element:getElement(), { layer = 3, anchors = {{ from = "CENTER", object = element:getElement(), to = "CENTER"}}, fontsize = settings.fontsize, color = settings.labelColor})
	element.labelShadow = UI.CreateFrame("nkExtText", name, element:getElement(), { layer = 2, anchors = {{ from = "CENTER", object = element.label:getElement(), to = "CENTER", x = 1, y = 1}}, fontsize = settings.fontsize, color = settings.borderColor})
		
	this.element = element
	setmetatable(this, self)
	self.__index = self
	return this
	
end

function nkGenie.ExtProgressBar:checkProps(attribute, value) return nkGenie.Tools.checkProps(self, attribute, value) end
function nkGenie.ExtProgressBar:checkAnchorUpdate(newAnchors) return nkGenie.Tools.checkAnchorUpdate(self, newAnchors) end

function nkGenie.ExtProgressBar:update (settings)

	if settings == nil then return end
	
	if settings.template ~= nil then
		for k, v in pairs (settings.template) do if settings[k] == nil then settings[k] = v end end
		settings.template = nil
	end	
	
	if self:checkProps('width', settings.width) == true then self.element:update({ width = settings.width }) end
	if self:checkProps('height', settings.height) == true then self.element:update({ height = settings.height }) end
	
	if settings.anchors ~= nil and self:checkAnchorUpdate (settings.anchors) == true then
		self.element:update ({ anchors = settings.anchors })
	end	
	
	if self:checkProps('text', settings.text) == true then self.element.label:update({ text = text }) end
	if self:checkProps('layer', settings.layer) == true then self.element:SetLayer(settings.layer) end
	if self:checkProps('strata', settings.strata) == true then self.element:SetStrata(settings.strata) end
	if self:checkProps('visible', settings.visible) == true then self.element:SetVisible(settings.visible) end
	
	if self:checkProps('percent', settings.percent) == true then	
		local width = (self.props.width - 4) * (settings.percent/100)
		self.element.fill:update ({ width = width })
		self.element.label:update ({ text = string.format ('%03d%%', settings.percent) })
		self.element.labelShadow:update ({ text = string.format ('%03d%%', settings.percent) })
	end
	
	for k, v in pairs (settings) do self.props[k] = v end
	
end

function nkGenie.ExtProgressBar:SetVisible(flag) 
	if self:checkProps('visible', flag) == true then 
		self:getElement():SetVisible(flag) 
		self.props.visible = flag
	end
end

function nkGenie.ExtProgressBar:getElement (innerFlag) return self.element end
